*******************************************************************************
*                         68008 Grundprogramm menue1                          *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2007 Jens Mewes                                 *
*                                 Rev 7.00                                    *
*                                01.09.2007                                   *
*                 Unterprogramme der Mensteuerung Teil 1                     *
*******************************************************************************

getstack:                       * In a7 steht Anfangssuchadresse
 move.l a5,d0
 bsr.s getram1                  * Ram-Bereich holen
 move.l a0,d0                   * Ende des Rambereiches
 subq.l #2,d0
 and.b #$fe,d0                  * Auf geraden Wert bringen ( Zur Sicherheit )
rts                             * Ergebnis auch in d0

                                * Ram-Bereich von a0 an suchen
                                * a0 ist Such-Anfang
                                * Ergebnis a0 = Nchste Nicht-Ram-Zelle
                                *          a1 = Erste Ram-Zelle
                                * Carry dann kein Bereich vorhanden
getram:
 move.l a0,d0
getram1:
 and.w #$fc00,d0                * Auf 1 Kbyte-Grenze bringen
 movea.l d0,a0
get1ram:
 cmpa.l #1024*1024*cpu-1024-1,a0 * 1 Mbyte - 1 KByte IO-Bereich
 bhi carset                     * Wenn grer, dann Fehler
 bsr.s ramchk                   * berprfen, ob Ram
 bcc.s get2ram                  * Ja, Ram Anfang gefunden
 adda #$400,a0                  * Sonst
bra.s get1ram                   * weitersuchen

get2ram:
 movea.l a0,a1                  * Erste Ram-Zelle merken
get3ram:
 cmpa.l #1024*1024*cpu-1024-1,a0* Noch mal Grenze testen
 bhi carres
 bsr.s ramchk                   * Ramende suchen
 bcs carres                     * Gefunden, dann Carry = 0
 adda #$400,a0                  * Sonst weitersuchen
bra.s get3ram

ramchk:                         * Prfen, ob Ram
 movem.l d0-d3,-(a7)            * Register retten
 movem.l (a0)+,d0-d3            * Speicher retten
 move.l #$5a5a0180,-(a0)        * Speicher beschreiben
 move.l #$5a01805a,-(a0)
 move.l #$01805a5a,-(a0)
 move.l #$805a5a01,-(a0)
 cmp.l #$805a5a01,(a0)          * Jetzt berprfen, ob Werte gespeichert sind
 bne.s ramchk1                  * Nein !
 cmp.l #$01805a5a,4(a0)
 bne.s ramchk1                  * Nein !
 cmp.l #$5a01805a,8(a0)
 bne.s ramchk1                  * Nein !
 cmp.l #$5a5a0180,12(a0)
 bne.s ramchk1                  * Nein !
 movem.l d0-d3,(a0)             * OK, alle Werte gespeichert
 movem.l (a7)+,d0-d3            * Register zurck
bra carres                      * Carry = 0
ramchk1:
 movem.l (a7)+,d0-d3            * Kein Ram
bra carset                      * Carry = 1

romchk:                         * Testen, ob Rom
 movem.l d0-d3,-(a7)            * Register retten (Speicher nicht, da kein Ram)
 movem.l (a0)+,d0-d3            * Werte holen zum Vergleich
 move.l #$5a5a0180,-(a0)        * Speicher vollschreiben
 move.l #$5a01805a,-(a0)
 move.l #$01805a5a,-(a0)
 move.l #$805a5a01,-(a0)
 cmp.l (a0),d0                  * Werte mssen gleich sein, da keine
 bne.s romchk1                  * Vernderung im Eprom auftreten kann
 cmp.l 4(a0),d1
 bne.s romchk1
 cmp.l 8(a0),d2
 bne.s romchk1
 cmp.l 12(a0),d3
 bne.s romchk1                  * Werte sind gleich, also kein Ram
 cmp.l d0,d1                    * Jetzt Werte untereinander testen
 bne.s romchk0                  * Wenn gleich, dann kein Rom, da im Rom
 cmp.l d0,d2                    * normalerweise nicht 16 Werte hintereinander
 bne.s romchk0                  * gleich sind (Leeres Eprom wird nicht erkannt)
 cmp.l d0,d3
 beq.s romchk1
romchk0:
 movem.l (a7)+,d0-d3            * Ist Rom
bra carres                      * Carry lschen
romchk1:
 movem.l (a7)+,d0-d3            * Kein Rom
bra carset                      * Carry setzen

ausspber:                       * Speicherbereiche ausgeben
 lea spber1(pc),a0              * berschrift
 bsr headaclr                   * ausgeben
 lea spber2(pc),a0              * Text fr Arbeitsbereich
 moveq #$22,d0
 moveq #60,d1
 move #195,d2
 bsr textprint                  * Text ausgeben
 movea.l a5,a0                  * Beim Ram hinterm Grundprogramm anfangen
 bsr getram                     * Ram suchen
 move.l a1,d0                   * Anfang ausgeben
 move.l a0,d1                   * Ende merken
 lea ausbuf(a5),a0              * In ausbuf
 bsr print8x                    * Hexadezimal ausgeben
 move.b #'-',(a0)+              * Bis
 move.l d1,d0                   * Jetzt Ende ausgeben
 subq.l #1,d0                   * -1, da erste Nicht-Ram-Zelle angegeben war
 bsr print8x                    * Auch hexadezimal
 lea ausbuf(a5),a0              * ausbuf ausgeben
 moveq #$22,d0
 move #300,d1
 bsr textprint                  * Text ausgeben
 moveq #$21,d0
 moveq #71,d1
 move #172,d2
 bsr setprt                     * GDP einstellen fr Zahlenreihe
 lea prttab(pc),a1              * Hexadezimalwerte 0 bis F
 moveq #16-1,d3                 * 16 Werte
ausspb1:
 move.b (a1)+,d0                * Wert holen
 bsr cmd                        * und ausgeben
 add #28,d1                     * Neue X-Position
 bsr moveto                     * einstellen
dbra d3,ausspb1
 moveq #0,d3                    * Adresse
 moveq #0,d1                    * X-Pos
 move #170-8,d2                 * Jetzt erfolgt Ausgabe der Adressen an der
 moveq #16-1,d4                 * linken Seite
ausspb2:
 move d3,d0                     * Adresse
 lea ausbuf(a5),a0              * Ablage
 bsr print4x                    * Hexadezimal 4 Stellen
 lea ausbuf(a5),a0              * Jetzt ausgeben
 moveq #$21,d0                  * Gre
 bsr textprint
 add #$1000,d3                  * Nchste Adresse
 sub #10,d2                     * Y-Positon erniedrigen
dbra d4,ausspb2                 * Schleifenende
 moveq #61,d1                   * X-Anfang
 moveq #10*2,d2                 * Y-Anfang
 move #16*28+3,d3               * Breite
 move #160*2+2,d4               * Hhe
 bsr gr1p5_                     * Rechteck leer (Auf Hilfslabel springen)
 bsr wait
 move.b #25,gdp+5*cpu.w         * Gre der Linien
 suba.l a0,a0                   * Anfangsadresse = 0
 moveq #64,d1                   * Anfangsposition X
 moveq #16-1,d5                 * 16 Bnke
ausbank:
 move #170,d2                   * Y-Anfangsposition
 moveq #$10,d0                  * Befehl Linie zeichnen
 moveq #32-1,d4                 * 32 Linien pro Bank
ausreihe:
 bsr wait
 clr.b gdp+2*cpu.w              * Linien durchgezogen
 bsr ramchk                     * fr Ramtest
 bcc.s aus1reihe                * Ram, dann ausgeben
 move.b #1,gdp+2*cpu.w          * Linien gestrichelt
 bsr romchk                     * fr Romtest
 bcs.s aus3reihe                * Fehler, dann weder Ram noch Rom
aus1reihe:
 moveq #5-1,d3
aus2reihe:
 bsr moveto
 bsr cmd                        * Linie zeichnen
 subq #1,d2                     * Neue Y-Position
dbra d3,aus2reihe
 addq #5,d2                     * d2 wieder auf alten Wert bringen
aus3reihe:
 adda #$800,a0                  * Nchste Adresse
 cmpa.l #1024*1024*cpu-1024-1,a0* 1 Kbyte IO-Bereich
 bhi finmenue
aus4reihe:
 subq #5,d2                     * Nchste Y-Position
dbra d4,ausreihe
 add #28,d1                     * Nchste Bank
dbra d5,ausbank
bra finmenue

einzel:                         * Einzelschrittverarbeitung mit DIS-Assembler
 btst.b #4,tracflag(a5)         * Trace nicht im Trace aufrufen
 bne carset
 lea tractxt0(pc),a0            * berschrift ausgeben
 bsr headaclr
 lea tractxt1(pc),a0            * Befehlsbersicht
 moveq #$32,d0
 move #160,d2
 bsr centertxt                  * berschrift
 lea tractxt2(pc),a0
 moveq #$21,d0
 moveq #5,d1
 move #140,d2
 bsr textprint                  * Befehle auflisten
 bsr getadr                     * Adresse Beginn holen
 bcs carset                     * Bei Fehler Abbruch
 move.l a7,stackmerk(a5)        * Stack merken, daher TRACE auch als Unterprogr
 or.b #%00010000,tracflag(a5)   * Trace ist jetzt an
 move.b #1,first(a5)            * Turtle erster Aufruf
 move.b #1,turdo(a5)            * Turtle down
 pea tracende(pc)               * Rcksprungadresse
 move.l d0,-(a7)                * PC am Anfang
 move sr,-(a7)                  * Statusregister merken
 bsr clrall                     * Bildschirm lschen
 clr.b tracausw(a5)             * Kein Extramodus
 clr.b trac1aus(a5)             * Kein Merker
 movem.l d0-d7/a0-a7,regsave(a5)* Alle Register merken
bra traceb

tracein:                        * Einsprung Ausnahme-Bedingung durch TRACE-BIT
 move.l a5,-(a7)                * (a7) -> SR     2(a7) -> PC
 lea basis(pc),a5
 adda.l ramstart(pc),a5         * a5 in Ordnung bringen
 movem.l d0-d7/a0-a6,regsave(a5)* Register bergeben
 move.l (a7)+,regsave+4*13(a5)  * a5 jetzt auch ablegen
 move.l a7,regsave+4*15(a5)     * Jetzt erst a7 retten
 lea tracende(pc),a0            * Ist Ende des Programms erreicht ?
 cmpa.l 2(a7),a0
 beq tracende                   * Ja, also Ende TRACE
 tst.b tracausw(a5)             * Spezialmodus angeschaltet ?
 beq.s traceb                   * Nein, dann weiter
 cmp.b #1,tracausw(a5)          * n-Befehle ausfhren
 bne.s tracea
 subq.l #1,tracmerk(a5)         * Tracmerk um Eins verringern
 bne traceok1                   * Wenn Null, dann Ende
bra.s tracea3                   * Normal weiter
tracea:
 cmp.b #2,tracausw(a5)          * Bis Adresse ausfhren
 bne.s tracea1
 move.l tracmerk(a5),d0         * Vergleich, ob
 sub.l 2(a7),d0                 * Bereich
 bpl.s tracea0
 neg.l d0                       * Nur positiver Bereich
tracea0:
 moveq #0,d1
 move tracmerk+4(a5),d1         * Bereich
 cmp.l d1,d0
 bhi traceok1                   * Bereich nicht erreicht
bra.s tracea3                   * Normal weiter
tracea1:
 cmp.b #3,tracausw(a5)          * Ausfhren bis ADRESSE & MASKE WERT annimmt
 bne.s tracea2
 movea.l tracmerk(a5),a0        * Adresse
 move.b (a0),d0                 * Maske
 and.b tracmerk+4(a5),d0
 cmp.b tracmerk+5(a5),d0        * Vergleich
 bne traceok1                   * Nein, Adresse hat nicht gewnschten Wert
bra.s tracea3                   * Normal weiter
tracea2:
 cmp.b #4,tracausw(a5)          * Bis ENDE Unterprogramm
 bne.s traceb
 movea.l 2(a7),a0
 move (a0),d0
 cmp #$4e75,d0                  * RTS
 beq.s tracea3
 cmp #$4e73,d0                  * RTE
 beq.s tracea3
 cmp #$4e77,d0                  * RTR
 bne traceok1                   * Durchstarten, da nicht gefunden

tracea3:
 clr.b tracausw(a5)             * Spezialmodus aus, normal weiter

traceb:
 move (a7),srsave(a5)           * SR jetzt merken
 move.l 2(a7),pcsave(a5)        * PC jetzt merken
 move.l usp,a0                  * USP auch ablegen
 move.l a0,uspsave(a5)
 move.l a7,sspsave(a5)          * SSP ist a7
 lea gdp+1*cpu.w,a0             * GDP-Register retten, da zerstrt
 lea gdpsave(a5),a1             * Register Null nicht retten
 bsr wait                       * Warten bis GDP fertig ist
 moveq #15-4-1,d1
tracec:
 move.b (a0)+,(a1)+             * ==> Nur fr 68008
dbra d1,tracec
                                * OK, Register gerettet
traced:                         * Status-Zeilen ausgeben
 bsr trdump                     * Alle Register / DEBUG oder DIS-ASsembler
 bcs.s tracee
 btst.b #1,tracflag(a5)         * Protokol auf Drucker ?
 beq.s tracee                   * Nein
 clr.b (a1)                     * Keine Leerzeichen mehr am Ende
 lea einbuf(a5),a0              * Ja, dann DEBUG oder DIS-Assembler ausgeben
 move.l pcsave(a5),d0           * Adresse Befehl
 bsr print8x                    * Hexadezimal ausgeben
 move #'  ',(a0)+               * Dann Leerzeichen
 clr.b (a0)                     * und Endekennung
 lea einbuf(a5),a0
 bsr prtlo                      * Auf Drucker ausgeben
 lea ausbuf(a5),a0
 bsr prtlo                      * Und Befehl auch auf Drucker ausgeben
 bsr locrlf                     * Dann Linefeed

tracee:                         * Befehlsabfrage
 bsr ki                         * Zeichen von Tastatur holen
 cmp.b #$d,d0                   * Return fhrt nchsten Befehl aus
 beq traceok

traceeb:                        * Bis ADRESSE + Bereich ausfhren
 cmp.b #'B',d0
 bne.s traceec
 bsr wrtupd0                    * Eingabe
 movea.l a0,a4                  * Adresse merken
traceeb0:                       * Suchen bis ','
 tst.b (a4)
 beq.s traceeb1                 * Ende bei Null
 cmp.b #',',(a4)+
 bne.s traceeb0
 clr.b -1(a4)                   * Ende fr ersten Wert
traceeb1:
 bsr wertmfeh                   * Ersten Wert holen
 bcs tracee                     * Ende bei Fehler
 move.l d0,tracmerk(a5)         * Adresse merken
 move.l d0,trac1mer(a5)         * Auch fr WIEDERHOLEN
 clr tracmerk+4(a5)             * Bereich ist Null
 movea.l a4,a0                  * Adresse fr eventuellen zweiten Wert
 bsr igbn
 tst.b (a0)
 beq.s traceeb2                 * Kein Bereich
 clr.b trac1ausw(a5)            * Kein Wiederholen mehr mglich
 bsr wertmfeh                   * Bereich holen
 bcs tracee                     * Fehler
 move d0,tracmerk+4(a5)         * Bereich merken
traceeb2:
 move.b #2,tracausw(a5)         * Flag
 move.b #2,trac1aus(a5)         * Auch merken
bra traceok                     * Durchstarten

traceec:                        * Screen lschen
 cmp.b #'C',d0
 bne.s traceed
 bsr clrall                     * Bildschirm lschen alle Seiten
 bsr trdump                     * Regdump neu ausgeben
bra tracee

traceed:                        * TRAP/JSR direkt ausfhren oder nicht
 cmp.b #'D',d0
 bne.s traceee
 bchg.b #2,tracflag(a5)         * Flag umschalten
 bsr trdump                     * Regdump neu
bra tracee

traceee:
 cmp.b #'E',d0                  * Bis RTS/RTE/RTR
 bne.s traceef
 move.b #4,tracausw(a5)         * Code fr Befehl
 move.b #4,trac1aus(a5)         * Fr Wiederholen
bra traceok

traceef:                        * Flags laden
 cmp.b #'F',d0
 bne.s traceeg
 bsr wrtupdate                  * Wert holen
 bcs tracee                     * Fehler ist Abbruch
 cmp #31,d0                     * Wert nicht neagtiv
 bhi tracee                     * und nicht grer als 31, da Flags nur 5 Bit
 move.b d0,srsave+1(a5)         * Flags abspeichern
 move.b d0,1(a7)                * Auch in Stack, damit bei RTE geladen wird
 bsr trdump                     * Regdump neu
bra tracee

traceeg:                        * Grundprogrammroutinen aufrufen
 cmp.b #'G',d0
 bne.s traceei
 bsr wrtupdate                  * Wert holen
 bcs tracee                     * Bei Fehler Abbruch
 move d0,d1                     * Wert merken
 bpl.s traceeg1                 * Wenn Wert positiv, dann OK
 neg d1                         * Sonst positiv machen
 cmp #maxgrund,d1               * Und mit maximaler Anzahl vergleichen
 bhi tracee                     * Zu hoch, Abbruch
 cmp #21,d1                     * Trace kann nicht Trace aufrufen
 beq tracee
traceeg1:
 move.b menflag(a5),-(a7)       * Menauswahl merken
 bsr grund                      * Aufrufen
 move.b (a7)+,menflag(a5)       * Auch wieder zurck
 bsr clrall                     * Danach wieder Bildschirm lschen
 bsr trdump                     * Regdump neu
bra tracee

traceei:                        * Info an/aus
 cmp.b #'I',d0
 bne.s traceel
 bchg.b #0,tracflag(a5)         * Flag ndern
 bne.s *+10                     * Wenn jetzt auf Eins, dann nur ausgeben
 bsr trdump                     * Regdump neu
bra tracee
 bsr.s traceei0                 * Sonst unten lschen
 bsr.s traceei0                 * Lschen
 bsr setpen                     * Wieder auf Schreiben
bra tracee                      * Nchsten Befehl holen

traceei0:                       * Unten 6 Zeilen lschen
 bsr erapen                     * Auf Lschen schalten
 move.b #5,gdp.w                * X und Y auf Null
 move.b #$16,gdp+3*cpu.w        * Gre einstellen
 moveq #%1010,d0                * Kasten
 moveq #85-1,d3
traceei1:
 bsr cmd                        * Lschzeichen ausgeben
dbra d3,traceei1
 eori.b #1,wrtpage(a5)          * Danach andere Seite
bra aktpage                     * Da, zweimal aufgerufen, spter wieder OK

traceel:                        * Extrafunktionen wiederholen
 cmp.b #'L',d0
 bne.s traceem
 move.b trac1aus(a5),tracausw(a5)       * Flag holen
 beq tracee                     * Kein Widerholen mglich
 move.l trac1mer(a5),tracmerk(a5)       * Und Wert neu laden
bra traceok                     * Durchstarten

traceem:                        * Tracende
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq tracende
 cmp.b #'M',d0
 beq tracende                   * Abbruch

traceen:                        * n Befehle ausfhren
 cmp.b #'N',d0
 bne.s traceep
 bsr wrtupdate                  * Anzahl holen
 bcs tracee                     * Abbruch bei Fehler
 tst.l d0                       * Wenn Null oder
 beq tracee                     * Negativ
 bmi tracee                     * dann Abbruch
 move.l d0,tracmerk(a5)         * Anzahl abspeichern
 move.l d0,trac1mer(a5)
 move.b #1,tracausw(a5)         * Flag fr Befehl
 move.b #1,trac1aus(a5)
bra traceok                     * Durchstarten

traceep:                        * PC neu laden (Achtung eventuell Stackchaos)
 cmp.b #'P',d0
 bne.s traceer
 bsr wrtupdate                  * Wert holen
 bcs tracee                     * Abbruch
 cmp.l #1024*1024*cpu-1024-1,d0 * Maximale Speicherausbaumglichkeit darf nicht
 bhi tracee                     * berschritten werden
 and.b #$fe,d0                  * Auf gerade Adresse
 move.l d0,2(a7)                * Abspeichern fr RTE
 move.l d0,pcsave(a5)           * Auch fr Regdump
bra traced                      * Regdump mit neuer Adresse

traceer:                        * Register einzeln laden
 cmp.b #'R',d0                  * Register + Nummer d0-d7/8 a0-a7
 bne tracees                    * Bei Eingabe einer 8 werden alle Register
 bsr wrtupd0                    * angezeigt
 bsr igbn
 move.b (a0)+,d0
 bsr bucheck
 move.b d0,d4                   * d4 ist Buchstabe fr Register
 lea regsave(a5),a4             * Adresse in REGSAVE fr Datenregister
 cmp.b #'D',d0                  * 'D' ?
 beq.s traceer0                 * Dann Datenregister ndern
 lea regsave+4*8(a5),a4         * Adrese  fr Adressregister
 cmp.b #'A',d0                  * 'A' ?
 bne tracee                     * Dann Adressregister ndern
traceer0:                       * d5 Tabellen-Offset
 bsr wertmfeh                   * d4 Buchstabe des Registers
 bcs tracee
 move d0,d6                     * d6 Nummer des Registers
 cmp #8,d0
 bhi tracee                     * Zu gro !
 beq.s traceer1
 bsr.s traceer3                 * Nur ein Register ndern
bra tracee
traceer1:
 clr    d6                      * 7 Register ndern
traceer2:
 move   d6,-(a7)
 bsr.s  traceer3                * Register ndern
 move   (a7)+,d6
 addq   #1,d6
 cmp    #8,d6
bne.s traceer2
bra tracee                      * Ende

traceer3:
 move d6,d5
 add d5,d5
 add d5,d5                      * Nummer des Registers mal 4
 lea 0(a4,d5.w),a3              * Adresse des Registers in REGSAVE
traceer4:
 lea einbuf(a5),a0
 move.b d4,(a0)+
 move.b d6,(a0)
 add.b #'0',(a0)+
 move.w #':'*256,(a0)
 subq.l #2,a0
 moveq #$11,d0
 moveq #2,d1
 move #245,d2
 bsr textaus                    * Ausgabe Registernummer mit Doppelpunkt
 move.l (a3),d0
 bsr put8x                      * Wert in Hexadezimal
 lea einbuf(a5),a0
 moveq #$11,d0
 moveq #20,d1
 moveq #12,d3
 move d4,-(a7)                  * d4 merken
 bsr readaus                    * Neuen Wert holen
 movem (a7)+,d4                 * d4 zurck
 bcs carres                     * Abbruch
 lea einbuf(a5),a0
 bsr igbn
 tst.b (a0)
 beq carres                     * Wenn nichts eingegeben wurde, dann Ende
 bsr wertmfeh                   * Wert ermitteln
 bcs.s traceer4                 * Fehler
 move.l d0,(a3)                 * Register abspeichern
bra trdump

tracees:                        * Leseseite neu whlen
 cmp.b #'S',d0
 bne.s traceet
 bsr wrtupdate                  * Seite holen
 bcs tracee
 cmp.b #3,d0                    * Mu zwischen 0 und drei liegen
 bhi tracee
 clr.b flip(a5)                 * Keine Seitenumschaltung mehr
 clr.b flip1(a5)
 move.b d0,viewpage(a5)         * Und einstellen
 bsr aktpage
 bsr trdump                     * Regdump neu
bra tracee

traceet:                        * Tabellieren auf Drucker (an/aus)
 cmp.b #'T',d0
 bne.s traceew
 bchg.b #1,tracflag(a5)         * Umschalten
 bsr trdump                     * Regdump neu
bra tracee

traceew:                        * Weiter bis ADRESSE & MASKE WERT enthlt
 cmp.b #'W',d0
 bne tracee
 bsr wrtupdate                  * Adresse holen
 bcs tracee                     * Bei Fehler Abbruch
 clr.b trac1aus(a5)             * Kein Wiederholen mehr mglich
 move.l d0,tracmerk(a5)         * Merken
 move.l d0,trac1mer(a5)
 bsr wrtupdate                  * Maske holen
 bcs tracee
 move.b d0,tracmerk+4(a5)       * Auch merken
 bsr wrtupdate                  * Wert holen
 bcs tracee
 move.b d0,tracmerk+5(a5)       * Auch merken
 move.b #3,tracausw(a5)         * Nummer des Befehls
 move.b #3,trac1aus(a5)

traceok:                        * Befehl ausfhren
 lea gdp+1*cpu.w,a0             * GDP-Register zurck
 lea gdpsave(a5),a1
 bsr wait                       * Warten bis GDP fertig ist
 moveq #15-4-1,d1
traceok0:
 move.b (a1)+,(a0)+             * ==> Nur fr 68008
dbra d1,traceok0
traceok1:
 btst.b #2,tracflag(a5)
 beq.s traceok2                 * TRAP/JSR geschlossen ausfhren ?
 movea.l 2(a7),a0               * Ja, geschlossen ausfhren
 move (a0),d0
 cmp #$4eb8,d0
 beq.s jsrkex                   * JSR.w Befehl
 cmp #$4eb9,d0
 beq.s jsrlex                   * JSR.l Befehl
 and #$fff0,d0
 cmp #$4e40,d0
 beq.s trapex                   * Trap
traceok2:
 or #$8000,(a7)                 * Tracflag neu setzen
 movem.l regsave(a5),d0-d7/a0-a6* Register zurck
rte                             * Zurck und nchsten Befehl ausfhren

jsrkex:                         * JSR.w als Ganzes ausfhren
 move.l (a0),modber(a5)
 move #$4e75,modber+4(a5)
 addq.l #4,2(a7)                * Befehl + RTS abgespeichert PC erhht
bra.s trapex1

jsrlex:                         * JSR.l als Ganzes ausfhren
 move (a0),modber(a5)
 move.l 2(a0),modber+2(a5)
 move #$4e75,modber+6(a5)       * Befehl + RTS abgespeichert
 addq.l #6,2(a7)                * PC erhht
bra.s trapex1

trapex:                         * Trap als Ganzes ausfhren
 move (a0),modber(a5)
 move #$4e75,modber+2(a5)
 addq.l #2,2(a7)                * Befehl + RTS abgespeichert PC erhht
trapex1:
 move (a7),d0
 and #$3fff,d0
 move d0,sr                     * Altes Statusregister ohne TRACE
 pea jsrtrapex(pc)
 pea modber(a5)                 * Adresse der Befehlsausfhrung
 movem.l regsave(a5),d0-d7/a0-a6* Register zurck
rts

jsrtrapex:
 movem.w d0,-(a7)
 move sr,d0
 move.b d0,3(a7)                * Flags wie am Ende des Unterprogramms
 move.w (a7)+,d0
bra tracein                     * Einsprung wie bei Exception

tracende:                       * Ende TRACE
 bclr.b #4,tracflag(a5)         * Trace aus
 movea.l stackmerk(a5),a7       * Stack zurck, falls mittendrin abgebrochen
 move.b #1,first(a5)            * Turtle auf first
 move.b #1,turdo(a5)            * Und down
 clr.b flip(a5)                 * Keine Seitenumschaltung
 clr.b flip1(a5)
 clr oldsize(a5)                * Keine alte Figur
 clr.b xormode(a5)              * XORMODE mu aus
 clr.b gdpscroll(a5)            * Merken
 btst.b #0,ioflag(a5)
 beq erakreuz
 clr.b page1.w                  * Bei neuer GDP Scroll ausschalten
bra erakreuz                    * Kreuz sicherheitshalber aus

wrtupdate:                      * Wert nach d0 holen fr Trace
 bsr.s wrtupd0
bra wertmfeh                    * Wert berechnen mit Fehlerbehandlung

wrtupd0:
 move.b viewpage(a5),d0
 lsl.b #2,d0
 or.b viewpage(a5),d0
 lsl.b #4,d0
 bsr setpage                    * Leseseite = Schreibseite setzen
 lea einbuf(a5),a0
 moveq #$11,d0
 moveq #2,d1
 move #255-10,d2
 moveq #20,d3
 bsr textein                    * Text von der Tastatur holen
 bsr aktpage                    * Alte Seite einstellen
 lea einbuf(a5),a0
rts

trdump:
 btst.b #0,tracflag(a5)
 beq carset                     * Kein Regdump
regdump:                        * Ausgabe aller Register und DEBUG
 lea ausbuf(a5),a0
 move.l #'Reg:',(a0)+           * Erste Zeile herstellen
 moveq #'0',d0
 moveq #8-1,d1
regdump0:
 move #'  ',(a0)+
 move.b d0,(a0)+                * Nummer des Registers 0-7
 addq.b #1,d0
 move.b #' ',(a0)+
 move #'  ',(a0)+
 move.l #'    ',(a0)+
dbra d1,regdump0
 clr.b (a0)                     * Endekennung
 btst.b #4,tracflag(a5)
 beq.s regdump2                 * Kein Trace, dann weiter
 btst.b #2,tracflag(a5)         * TRAP/JSR direkt ausfhren ?
 bne.s regdump1                 * Nein, dann weiter
 move.b #'D',-1(a0)             * Kennung, da direkt ausgefhrt wird
regdump1:
 btst.b #1,tracflag(a5)         * Protokol auf Drucker an ?
 beq.s regdump2                 * Nein, dann weiter
 move.l #'List',-6(a0)          * Kennung, da Protokol an ist
regdump2:
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #0,d1
 moveq #40,d2
 bsr textaus                    * Oberste Zeile ausgeben
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * Andere Seite
 moveq #$11,d0
 bsr textaus                    * Auch dort
 lea ausbuf(a5),a0
 move.l #'Dn :',(a0)+           * Alle Datenregister
 lea regsave(a5),a1             * Dort liegen sie
 moveq #8-1,d1                  * 8 gibt es
regdump3:
 move #'  ',(a0)+               * Dazwischen Leerraum
 move.l (a1)+,d0                * Wert holen / liegt in regsave
 bsr print8x                    * Hexadezimal ausgeben
dbra d1,regdump3
 addq.l #2,a0
 move.l #'An :',(a0)+           * Jetzt Adressregister
 moveq #8-1,d1                  * Auch 8
regdump4:
 move #'  ',(a0)+
 move.l (a1)+,d0
 bsr print8x
dbra d1,regdump4
 addq.l #2,a0
 move.l #'SR :',(a0)+           * Statusregister
 move.w #'  ',(a0)+
 move srsave(a5),d0
 move d0,d1
 bsr print16b                   * 16 Stellen binr ausgeben
 move.b #'-',-15(a0)            * Unbenutzte Bits streichen
 move.b #'-',-13(a0)            * ist bersichtlicher
 move.b #'-',-12(a0)
 move #'--',-8(a0)
 move.b #'-',-6(a0)
 lea flags(pc),a2               * Gesetzte Flags als Buchstaben ausgeben
 lea 1(a0),a1                   * Zieladresse
 move.l #'    ',(a0)+
 move.l #'   U',(a0)+
 moveq #5-1,d0                  * 5 Flags gibt es
regdump5:
 btst d0,d1                     * Flag prfen, ob gesetzt
 beq.s regd5a
 move.b (a2),(a1)+              * Gesetzt, also ausgeben
regd5a:
 addq.l #1,a2                   * Nchster Buchstabe
dbra d0,regdump5                * Nchstes Bit
 move.l #'SP :',(a0)+           * Jetzt USP
 move.w #'  ',(a0)+
 move.l uspsave(a5),d0
 bsr print8x                    * Hexadezimal 8 Stellen
 move.l #'    ',(a0)+           * Leerraum
 move.l #' SSP',(a0)+
 move.w #' :',(a0)+
 move.w #'  ',(a0)+
 move.l Sspsave(a5),d0          * Jetzt ISP
 bsr print8x                    * Auch 8 Stellen hexadezimal
 move.l #'    ',(a0)+           * Leerraum
 move.l #'  PC',(a0)+
 move.l #' :  ',(a0)+           * Jetzt PC
 move.l pcsave(a5),d0
 bsr print8x                    * 8 Stellen hexadezimal
 moveq #2-1,d3                  * Alles auf zwei Seiten ausgeben
regdump6:
 lea ausbuf(a5),a0              * Zweite Zeile
 moveq #$11,d0
 moveq #0,d1
 moveq #30,d2
 bsr textaus
 lea ausbuf+86(a5),a0           * Dritte Zeile
 moveq #20,d2
 bsr textaus
 lea ausbuf+172(a5),a0          * Vierte Zeile
 moveq #10,d2
 bsr textaus
 eori.b #1,wrtpage(a5)          * Andere Seite
 bsr aktpage
dbra d3,regdump6
regdin:                         * Einsprung
 tst.b debug(a5)                * Debug an ?
 beq.s nodebugi                 * Nein, dann DIS-Assembler
 movea.l debugst(a5),a0         * Anfangsadresse
 movea.l pcsave(a5),a1          * Befehlsadresse
regdump7:
 move.l (a0),d0
 beq.s nodebugi                 * Ende der Debugtabelle erreicht
 cmp.l a1,d0                    * Stimmt Adresse
 beq.s regdump8                 * Ja, stimmt
 addq.l #8,a0                   * Nein, Tabellenpointer erhhen
bra.s regdump7                  * Weitersuchen

flags:
 dc.b 'XNZVC',0                 * Flags des Statusregister

regdump8:                       * Befehl in der Tabelle gefunden
 movea.l 4(a0),a0               * Adresse Text holen
 lea ausbuf(a5),a1              * In ausbuf ablegen
 moveq #85-1,d1                 * Maximal 85 Zeichen
regdump9:
 move.b (a0)+,d0
 beq.s nodebug2                 * Null ist Ende
 cmp.b #$d,d0
 beq.s nodebug2                 * $d auch
 cmp.b #$a,d0
 beq.s regdump9                 * $a ignorieren
 move.b d0,(a1)+                * Buchstaben ablegen
dbra d1,regdump9                * Nchsten holen
 movea.l a1,a0                  * Merken fr Druckerausgabe
bra.s nodebugfi                 * Befehlstext ausgeben

nodebugi:                       * Wenn kein Debug, dann Disassembler
 movea.l pcsave(a5),a3          * Adresse des Befehls
 bsr disass                     * Dis-Assemblieren
nodebug0:
 lea einbuf(a5),a0              * In einbuf steht Dis-Assemblierter Befehl
 lea ausbuf(a5),a1              * Dort mu er hin
 moveq #85-1,d1
nodebug1:
 move.b (a0)+,(a1)+             * bertragen bis Null erreicht
dbeq d1,nodebug1
 subq.l #1,a1
nodebug2:
 movea.l a1,a0                  * Adresse merken fr Druckerausgabe
 tst d1
 bmi.s nodebugfi                * Ende, wenn Zeile voll
nodebug3:
 move.b #' ',(a0)+              * Rest mit Leerzeichen auffllen
dbra d1,nodebug3
nodebugfi:                      * Dis-Assembler oder DEBUG ausgeben
 clr.b (a0)                     * Endekennung
 lea ausbuf(a5),a0              * Dort steht Text
 moveq #$11,d0
 moveq #0,d1
 moveq #0,d2
 bsr textaus                    * Ausgeben
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * Andere Seite
 moveq #$11,d0
 bsr textaus                    * Auch dort ausgeben
 btst.b #4,tracflag(a5)
 beq carres                     * Kein Trace, dann Ende
 btst.b #1,tracflag(a5)         * Protokol auf Drucker ?
 beq carres                     * Nein
 clr.b (a1)                     * Keine Leerzeichen mehr am Ende
 lea einbuf(a5),a0              * Ja, dann DEBUG oder DIS-Assembler ausgeben
 move.l pcsave(a5),d0           * Adresse Befehl
 bsr print8x                    * Hexadezimal ausgeben
 move #'  ',(a0)+               * Dann Leerzeichen
 clr.b (a0)                     * und Endekennung
 lea einbuf(a5),a0
 bsr prtlo                      * Auf Drucker ausgeben
 lea ausbuf(a5),a0
 bsr prtlo                      * Und Befehl auch auf Drucker ausgeben
 bsr locrlf                     * Dann Linefeed
bra carres                      * Ausgabe erfolgte

ioread:                         * Wert von IO-Port lesen
 lea iomsg(pc),a0
 bsr headaclr                   * berschrift
 lea io1msg(pc),a0
 moveq #$33,d0
 moveq #10,d2
 bsr centertxt                  * Befehle
 bsr getadr                     * Adresse holen
 bcs carset                     * Fehler
 movea.l d0,a1                  * Adresse merken
io1rd:
 bsr.s ioprint                  * Ausgabe des Wertes
 bsr ki                         * Zeichen von Tastatur holen
 cmp.b #'D',d0
 bne.s io2rd
io11rd:                         * Dauernd ausgeben
 bsr sync                       * Mit 20 ms Abstand, damit Wert nicht flimmert
 beq.s io11rd
 bsr.s ioprint                  * Wert ausgeben
 bsr csts                       * Auf Zeichen von Tastatur warten
 beq.s io11rd                   * OK, kein Zeichen, also weiter ausgeben
 bsr ki                         * Sonst Zeichen holen
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq carres
 cmp.b #'M',d0                  * 'M' = Ende
 beq carres
 cmp.b #'S',d0                  * 'S' = Stop
 beq.s io1rd
 cmp.b #'R',d0                  * 'R' = Neue Adresse eingeben
 beq.s ioread
bra.s io11rd                    * Sonst weiter ausgeben

io2rd:
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq carres
 cmp.b #'M',d0                  * 'M' = Ende
 beq carres
 cmp.b #'R',d0                  * 'R' = Adresse neu eingeben
 beq.s ioread
bra.s io1rd                     * Auf nchstes Zeichen warten

ioprint:                        * IO-Wert ausgeben
 lea ausbuf(a5),a0
 move.b (a1),d0
 bsr print2x                    * Hexadezimal ausgeben
 lea ausbuf(a5),a0
 moveq #$22,d0
 move #224,d1
 move #135,d2
 bsr textaus
 lea ausbuf(a5),a0
 move.b (a1),d0
 bsr print4d                    * Dezimal ausgeben
 move.b #' ',(a0)+
 move.b #' ',(a0)+              * Leerzeichen, damit bei weniger Stellen
 clr.b (a0)                     * gelscht wird
 lea ausbuf(a5),a0
 moveq #$22,d0
 move #150,d1
 bsr textaus
 lea ausbuf(a5),a0
 move.b (a1),d0
 bsr print8b                    * Und binr ausgeben
 lea ausbuf(a5),a0
 moveq #$22,d0
 moveq #100,d2
bra textaus

iowrite:                        * Wert an IO-Port ausgeben
 lea iopmsg(pc),a0
 bsr headaclr                   * berschrift
 bsr getadr                     * Adresse holen
 bcs carset                     * Fehler
 movea.l d0,a3                  * Adresse merken
 lea datamsg(pc),a0
 moveq #$22,d0
 moveq #20,d1
 move #150,d2
 bsr textprint                  * Text ausgeben 'DATA'
 lea einbuf(a5),a0
 moveq #90,d1
 moveq #30,d3
 bsr textein                    * Auszugebenden Wert holen
 bcs carset                     * Abbruch
 lea einbuf(a5),a0
 bsr wertmfeh                   * Wert berechnen
 bcs carset                     * Fehler
 move.b d0,(a3)                 * Wert ausgeben
 lea iop1msg(pc),a0
 moveq #$33,d0
 moveq #20,d2
 bsr centertxt                  * Befehle
iopw1:
 bsr ki                         * Auf Zeichen von Tastatur warten
 cmp.b #'R',d0                  * 'R' = neue Adresse eingeben
 beq.s iowrite
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq.s iopw2
 cmp.b #'M',d0                  * 'M' = Ende
 bne.s iopw1
iopw2:
rts

promein:                        * Eprom und Karte auswhlen
 movea.l a0,a1                  * a0 = berschrift
 bsr headaclr                   * berschrift ausgeben
 lea txtpein(pc),a0
 moveq #$21,d0
 moveq #20,d1
 move #203,d2
 bsr textprint                  * Auswahltext
 clr d3
 move.b akteprom(a5),d3
 muls #19,d3
 lea 4(a0,d3.w),a0              * Text fr voreingestelltes Eprom
 moveq #68,d1
 moveq #23,d2
 bsr setprt                     * Voreinstellung fr Textausgabe
promein0:
 move.b (a0)+,d0
 cmp.b #10,d0                   * Bis zum Linefeed ausgeben
 beq.s promein1
 bsr cmdput                     * Zeichen ausgeben
bra.s promein0
promein1:
 lea einbuf(a5),a0
 moveq #$21,d0
 moveq #20,d1
 moveq #3,d2
 moveq #1,d3
 bsr textein                    * Einen Buchstaben lesen
 bcs carset                     * Abbruch
 move.b d5,d0
 bsr namecheck                  * In Grobuchstaben
 cmp.b #'Z',d0
 beq carset                     * 'Z' = Zurck
 cmp.b #'P',d0
 beq.s promein2                 * Alte Eprom-Einstellung
 sub.b #'A',d0                  * Mu zwischen
 bmi.s promein1                 * 0 und 14 liegen
 cmp.b #'O'-'A',d0
 bhi.s promein1
 move.b d0,akteprom(a5)         * Ergebnis 0 bis 14
promein2:
 bsr getpadr                    * a4 ist Adresse Leseroutine, Promer-Init OK
 movea.l a1,a0
 bsr headaclr                   * Nochmal berschrift
promein3:                       * Einsprung bei falschen Adressen
 lea txtp3(pc),a0
 bsr get3par                    * 3 Werte lesen
 bcs carset
 lea einbuf(a5),a0
 bsr wertmfeh                   * Letzten Wert berechnen
 bcs carset                     * Fehler
 move.l d0,d5                   * d5 = Dritter Wert
promein4:
 moveq #$22,d0
 move #150,d1
 moveq #120,d2
 moveq #28,d3
 lea einbuf(a5),a0
 move #(cpu+$30)*256,(a0)       * Voreinstellung fr CPU (1,2,4)
 move.l d5,-(a7)
 bsr readaus                    * Abstand der Bytes holen
 movem.l (a7)+,d5               * d5 nicht zerstren
 bcs carset                     * Abbruch
 lea einbuf(a5),a0
 bsr wertmfeh                   * Wert ermitteln
 bcs carset                     * Fehler
 move.l d0,d4
 beq.s promein4                 * Der Wert mu
 cmp #4,d4                      * 1, 2 oder 4 sein
 bhi.s promein4                 * Zu gro
 cmp #3,d4
 beq.s promein4                 * 3 ist nicht erlaubt
 moveq #0,d0                    * d4 ist jetzt Abstand der Bytes
 move.b akteprom(a5),d0
 move.b promtab0(pc,d0.w),d0    * Hchstes Byte des Eproms
 lsl.w #8,d0
 lsl.l #2,d0                    * Mal 1024
 subq.l #1,d0                   * -1, damit ist hchstes Bit markiert
bra carres

promtab0:                       * Tabelle der Lngen der Eproms
 dc.b 2,4,8                     * 2716,2732,2764
 dc.b 2,4,8                     * 2716,2732,2764
 dc.b 2,4,8,8,16,16,32,64,128   * 2716,2732,2764,2764,27128,27128,27256,27512
                                * 27010

promtab1:                       * Werte fr Initialisierung beim Promer2
 dc.b $28,$90,$00,$00,$90,$90   * 2716
 dc.b $28,$80,$90               * Werte frs Lesen
 dc.b $20,$90,$40,$40,$90,$90   * 2732
 dc.b $20,$80,$90
 dc.b $c0,$d2,$64,$60,$92,$92   * 2764a
 dc.b $c0,$82,$92
 dc.b $c0,$d2,$64,$60,$92,$92   * 2764b
 dc.b $c0,$82,$92
 dc.b $c0,$d2,$64,$60,$92,$92   * 27128a
 dc.b $c0,$82,$92
 dc.b $c0,$d2,$64,$60,$92,$92   * 27128b
 dc.b $c0,$82,$92
 dc.b $80,$d2,$64,$60,$92,$92   * 27256
 dc.b $80,$82,$92
 dc.b $00,$d2,$64,$60,$92,$92   * 27512
 dc.b $00,$82,$92
 dc.b $00,$fc,$60,$60,$dc,$9c   * 27010
 dc.b $00,$8c,$9c
 ds 0

getpadr:                        * Adresse fr Lesen auswhlen und Spannungen
 moveq #0,d0                    * sowie Werte fr Lesen einstellen, wenn Promer2
 move.b akteprom(a5),d0
 subq #6,d0
 bpl.s getpadr0                 * OK
 move.b #%01000000,proma2.w     * Neutral stellen, wenn Promer
 lea getprom(pc),a4             * Adresse Promer-Routine frs Lesen
rts
getpadr0:                       * Promer2
 mulu #9,d0
 lea promtab1(pc,d0.w),a3       * Adresse in der Tabelle
 move.b (a3)+,proma3.w          * Jetzt alle Werte bertragen (Adresse $83)
 move.b (a3)+,proma4.w          * $84
 move.b (a3)+,proma5.w          * $85
 move.b (a3)+,proma5.w          * $85
 move.b (a3)+,proma4.w          * $84
 move.b (a3)+,proma4.w          * $84
 lea getprom2(pc),a4            * Adresse Leseroutine
rts                             * a3 ist Zeiger auf Tabelle fr Lesewerte

getprom:                        * d5.l ist Adresse (wird um 1 erhht)
 move.b d5,proma1.w             * d0.b ist Ergebnis Wert
 move d5,d0
 lsr #8,d0
 or.b #%01000000,d0             * Neutral lassen
 move.b d0,proma2.w             * 2-tes Byte der Adresse
 addq.l #1,d5                   * Adresse erhhen
 move.b promd.w,d0              * Wert nach d0.b
rts

getprom2:                       * a3 = Adresse in Tabelle, d3 = Adresse im Eprom
 move.b d5,proma2.w             * Ergebnis d0.b = Wert
 move.l d5,d0
 lsr #8,d0
 or.b (a3)+,d0                  * Erstes Byte
 move.b d0,proma3.w             * Bits 8 bis 15 und eventuelle Spannungen
 swap d0
 or.b (a3)+,d0                  * Zweites Byte
 move.b d0,proma4.w             * Bits 16 bis 23 und eventuelle Spannungen
 addq.l #1,d5                   * Nchste Adresse
 nop                            * Sonst zu schnell
 move.b promd.w,d0              * Byte holen
 move.b (a3),proma4.w           * Neutral stellen
 subq.l #2,a3                   * Alte Adresse a3
rts

promread:                       * Eprom lesen
 lea txtp2(pc),a0
 bsr promein                    * Eprom und Karte auswhlen
 bcs carset                     * Ende
promr0:
 cmp.l d0,d6
 bhi.s promr1                   * Anfangsadresse falsch
 cmp.l d0,d7
 bls.s promr2                   * Endadresse richtig
promr1:
 bsr promein3                   * Eine Adresse falsch, deshalb neue Werte
 bcc.s promr0
bra carset
promr2:
 movea.l d5,a0                  * Ziel nach a0
 move.l d6,d5                   * Quelle nach d5
promr3:
 jsr (a4)
 move.b d0,(a0)                 * Wert aus Eprom an Adresse geben
 adda.l d4,a0                   * Nchstes Byte
 cmp.l d5,d7                    * Bis Ende erreicht
 bpl.s promr3                   * Schleife fortsetzen
bra carres                      * OK

promtab2:                       * Werte fr Promer2 beim Schreiben
 dc.b $10,$10,$81,$81,$10       * 2716
 dc.b 02,$28,$00,$10,$40,67,195+1,$00,$40,$80,$10,$90,00
 dc.b $50,$50,$b0,$b0,$50       * 2732
 dc.b 02,$20,$00,$50,$40,67,195+1,$00,$40,$90,$40,$d0,00
 dc.b $52,$52,$a4,$a6,$12       * 2764a
 dc.b 29,$c0,$40,$12,$00,214,3+1,$40,$00,$80,$10,$90,05
 dc.b $52,$52,$e4,$e6,$12       * 2764b
 dc.b 29,$c0,$40,$12,$00,214,3+1,$40,$00,$80,$10,$90,05
 dc.b $52,$52,$a4,$a6,$12       * 27128a
 dc.b 29,$c0,$40,$12,$00,214,3+1,$40,$00,$80,$10,$90,05
 dc.b $52,$52,$e4,$e6,$12       * 27128b
 dc.b 29,$c0,$40,$12,$00,226,1+1,$40,$00,$80,$10,$90,06
 dc.b $52,$52,$e4,$e6,$52       * 27256
 dc.b 29,$80,$00,$52,$40,88,0+1,$00,$40,$90,$00,$90,07
 dc.b $52,$52,$e4,$f4,$52       * 27512
 dc.b 29,$00,$00,$52,$40,88,0+1,$00,$40,$10,$c0,$d0,07
 dc.b $5c,$7c,$e8,$e8,$3c       * 27010
 dc.b 29,$00,$00,$3c,$04,88,0+1,$00,$04,$80,$10,$90,07
 ds 0

putpadr:
 lea proma1.w,a2                * Schreibadresse Low-Byte (Promer)
 lea proma2.w,a3                * Schreibadresse High-Byte (Promer)
 moveq #0,d0
 move.b akteprom(a5),d0         * Eprom-Typ holen
 subq #3,d0
 bpl.s putpadr0
 lea putproml(pc),a4            * Promer langsam
rts
putpadr0:
 subq #3,d0
 bpl.s putpadr1
 lea putproms(pc),a4            * Promer schnell
rts
putpadr1:
 mulu #18,d0
 lea promtab2(pc),a3
 adda d0,a3                     * Adresse der Epromdaten
 move.b (a3)+,proma4.w          * $84
 move.b (a3)+,proma4.w          * $84
 bsr wawa                       * Mindestens 0.3 ms warten
 move.b (a3)+,proma5.w          * $85
 bsr wawa                       * Mindestens 0.3 ms warten
 move.b (a3)+,proma5.w          * $85
 move.b (a3)+,proma4.w          * $84
 lea putprom2(pc),a4            * Promer2
 move.b #$b0,proma7.w           * Steuerwort Timer ($87)
rts
                                * Promer langsam
putproml:                       * d5 ist Adresse, d3 ist Wert
 move.b d3,promd.w              * a2, a3 sind Adressen Promer
 move d5,d2
 move.b d2,(a2)                 * Low Byte Adresse
 lsr #8,d2
 tas.b d2
 move.b d2,(a3)                 * High Byte Adresse
 or.b #%00100000,d2
 move.b d2,(a3)                 * Triggern
 and.b #%11011111,d2
 move.b d2,(a3)
 moveq #3-1,d1                  * 3*20 ms = 60 ms warten
putprl0:
 bsr sync                       * 20 ms warten
 beq.s putprl0
dbra d1,putprl0
 and.b #%00011111,d2
 move.b d2,(a3)                 * Ohne Spannung
 nop                            * Sonst zu schnell
 cmp.b promd.w,d3               * Vergleichen, ob Wert richtig gebrannt ist
 beq carres
bra carset
                                * Promer schnell
putproms:                       * d5 ist Adresse, d3 ist Wert
 moveq #29,d6                   * a2, a3 sind Adressen Promer
putprs0:
 move.b d3,promd.w              * Wert an Promer
 move d5,d1
 move.b d1,(a2)                 * Untere 8 Bit
 lsr #8,d1
putprs1:
 bsr.s putprs4                  * Programmierimpuls
 bcc.s putprs2
dbra d6,putprs1                 * Durchgangszhler
bra carset                      * Fehler !!
putprs2:
 moveq #6-1,d6                  * 5 Sicherheitsimpulse
putprs3:
 bsr.s putprs4                  * Impuls
 bcs carset                     * Doch noch Fehler !!
dbra d6,putprs3
bra carres                      * OK

putprs4:
 tas.b d1                       * Vorderstes Bit auf 1 setzen
 move.b d1,(a3)                 * Adresse bergeben
 or.b #%00100000,d1
 move.b d1,(a3)                 * Triggern
 and.b #%11011111,d1
 move.b d1,(a3)
putprs5:
 btst.b #0,(a2)                 * Warten bis Ende des Impuls
 bne.s putprs5
 and.b #%00011111,d1
 move.b d1,(a3)                 * Neutral stellen
 nop                            * Sonst zu schnell
 cmp.b promd.w,d3
 beq carres                     * OK
bra carset

putprom2:                       * d5 = Adresse, d3.b = Wert, a3 = Tabelle
 movea.l a3,a2                  * a3 nicht zerstren
 moveq #0,d6
 move.b (a2)+,d6                * Maximale Schleifendurchgnge
 move.b d3,promd.w              * Zu programmierendes Byte
 move.l d5,d1                   * Low-Byte in d5
 swap d1                        * High-Byte in d1
 move.l d5,d2
 lsr #8,d2                      * Mid-Byte in d2
 move.b d5,proma2.w             * Low-Byte einstellen ($82)
 or.b (a2)+,d2
 move.b d2,proma3.w             * Mid-Byte einstellen ($83)
 bsr putp2wait                  * Etwas warten
putpr2a:                        * Programmierschleife
 bsr.s putpr2d                  * Programmierimpuls
 bcc.s putpr2b                  * OK, weiter
dbra d6,putpr2a
bra carset                      * Fehler
putpr2b:
 moveq #0,d6
 move.b 12(a3),d6               * Anzahl der Sicherheitsimpulse
 beq carres                     * Bei 2716 und 2732 keine Sicherheitsimpulse
putpr2c:
 bsr.s putpr2d                  * Impuls
 bcs carset                     * Doch noch Fehler
dbra d6,putpr2c
bra carres                      * OK

putpr2d:                        * Eigentlicher Impuls
 move.b (a2)+,d0
 eor.b d0,d2
 move.b d2,proma3.w             * Nochmal Mid-Byte ($83)
 or.b (a2)+,d1
 move.b d1,proma4.w             * High-Byte ($84)
 move.b (a2)+,d0
 move.b (a2)+,proma6.w          * Low-Byte Zhler ($86)
 eor.b d0,d1                    * Befehl hier, wegen Geschwindigkeit
 move.b (a2)+,proma6.w          * High-Byte Zhler $(86)
 move.b d1,proma4.w             * Nochmal High-Byte ($84)
 move.b (a2)+,d0
 eor.b d0,d2                    * Mid-Byte schon fertig, dadurch schneller, wenn
putpr2e:                        * Zeit um ist
 move.b #$80,proma7.w           * Zhlerstand speichern
 tst.b proma6.w                 * Low-Byte wegwerfen
 tst.b proma6.w                 * Nur High-Byte lesen. Wenn Null, dann Zeit
 bne.s putpr2e                  * abgelaufen, da 256 us addiert wurden. So wird
                                * auf jeden Fall der Nullpunkt erkannt
 move.b d2,proma3.w             * Mid-Byte auf $83 (Bei einigen Ende Pr-Impuls)
 bsr.s putp2wait                * Etwas warten
 move.b (a2)+,d0
 eor.b d0,d1
 move.b d1,proma4.w             * High-Byte ($84) (Beim Rest hier Ende Impuls)
 bsr.s putp2wait                * Etwas warten
 move.b (a2)+,d0
 eor.b d0,d1
 move.b d1,proma4.w             * High-Byte
 bsr.s putp2wait                * Warten
 move.b (a2)+,d0
 eor.b d0,d1
 move.b d1,proma4.w             * High-Byte
 move.b (a2),d0
 eor.b d0,d1                    * High-Byte vorbereiten
 suba #9,a2                     * Alte Adresse fr eventuellen neuen Durchgang
 bsr.s putp2wait                * Etwas warten
 cmp.b promd.w,d3               * Vergleichen, ob gebrannt
 sne.b d0                       * d0 danach setzen
 move.b d1,proma4.w             * High-Byte
 tst.b d0
 beq carres                     * OK
bra carset                      * Fehler

putp2wait:                      * Ca. 2 us warten (Mit Aufruf und RTS)
 moveq #0,d0
putp2w0:
 dbra d0,putp2w0
rts

promwrite:                      * Eprom programmieren
 lea txtp1(pc),a0
 bsr promein                    * Auswahl Eprom und Karte
 bcs carset
promw0:
 cmp.l d0,d5
 bhi.s promw1                   * Zieladresse zu gro
 sub.l d6,d7                    * Anzahl Bytes
 move.l d4,d1
 lsr.l #1,d1
 lsr.l d1,d7                    * Anzahl zu schreibender Bytes
 add.l d5,d7                    * Anfangsadresse dazu
 cmp.l d0,d7
 bls.s promw2                   * Bereich ist im Eprom
promw1:
 bsr promein3                   * Nochmal Werte lesen
 bcc.s promw0
bra carset
promw2:
 movea.l d6,a1                  * Quelladresse
 movem.l d5/a1,-(a7)            * Merken fr spter
promw3:
 jsr (a4)                       * Ein Byte holen und Adresse erhhen
 cmp.b #$ff,d0
 beq.s promw4                   * Wenn $FF, dann OK
 lea txtp4(pc),a0
 moveq #$22,d0
 moveq #95,d2
 bsr centertxt                  * Meldung, da Bereich nicht leer ist
bra.s promw5
promw4:
 cmp.l d5,d7                    * Bis letztes Byte geprft wurde
 bpl.s promw3
promw5:
 lea txtp5(pc),a0
 moveq #$32,d0
 moveq #75,d2
 bsr centertxt                  * Abfragetext frs Starten
 bsr ki
 cmp.b #'M',d0
 bne.s promw5a                  * 'M' = Ende
 addq.l #8,a7                   * Stack reinigen
bra carset
promw5a:
 cmp.b #'S',d0
 bne.s promw5                   * 'S' = Starten
 movem.l (a7),d5/a1             * Register wieder auf alten Wert
 lea txtp6(pc),a0               * d5 = Anfangsadresse Eprom
 moveq #$32,d0                  * d7 = Endadresse Eprom
 bsr centertxt                  * a1 = Anfangsadresse Ram
 bsr putpadr                    * Frs Programmieren initialisieren
promw6:
 bsr csts
 beq.s promw7                   * Weiter, wenn kein Zeichen von Tastatur
 bsr ci
 cmp.b #$1b,d0
 bne.s promw7                   * ESC ist Abbruch
 bsr getpadr                    * Auf Lesen (Spannungen)
 addq.l #8,a7                   * Stack reinigen
bra finmenue                    * Ende
promw7:
 move.b (a1),d3                 * Wert nach d3
 cmp.b #$ff,d3
 beq.s promw9                   * $FF nicht programmieren
 jsr (a4)                       * Wert Programmieren
 bcc.s promw9                   * Richtig Programmiert
 bsr promerror
 lea txtp7(pc),a0               * Fehler beim Programmieren
 moveq #$32,d0
 moveq #60,d1
 moveq #10,d2
 bsr textprint                  * Text ausgeben
 bsr ki                         * Zeichen holen
 cmp.b #'M',d0
 bne.s promw8                   * 'M', dann Ende
 bsr getpadr                    * Auf Lesen (Spannungen)
 addq.l #8,a7                   * Stack reinigen
bra finmenue                    * Ende
promw8:
 lea txtp7(pc),a0               * Sonst Text lschen und weiter programmieren
 moveq #$32,d0
 bsr erapen
 bsr textprint                  * Text lschen
promw9:
 addq.l #1,d5                   * Nchste Adresse im Eprom
 adda.l d4,a1                   * Nchste Adresse im Ram
 cmp.l d5,d7
 bpl.s promw6                   * Bis letztes Byte programmiert
 bsr getpadr
 movem.l (a7)+,d5/a1            * Werte zurck
promw10:                        * Prflesen
 jsr (a4)
 cmp.b (a1),d0                  * Wert aus Eprom an Adresse geben
 beq.s promw11                  * OK
 subq.l #1,d5                   * Alte Adresse
 bsr.s promerror                * Fehler beim Prflesen
 lea txtp8(pc),a0               * Fehler beim Programmieren
 moveq #$32,d0
 moveq #10,d2
 bsr centertxt                  * Text ausgeben
bra.s finmenue                  * Ende
promw11:
 adda.l d4,a1                   * Nchstes Byte
 cmp.l d5,d7                    * Bis Ende erreicht
 bpl.s promw10                  * Schleife fortsetzen
 lea txtp9(pc),a0               * OK
 moveq #$32,d0
 moveq #10,d2
 bsr centertxt                  * Text ausgeben, da erfolgreich programmiert
bra.s finmenue

promerror:                      * d5 = Zieladresse / a1 = Quelladresse
 lea ausbuf(a5),a0              * Adressen ausgeben
 move.l d5,d0
 bsr print6x                    * Zieladresse 5 Stellen
 move.w #'  ',(a0)+
 move.l a1,d0
 bsr print6x                    * Quelladresse 6 Stellen
 lea ausbuf+1(a5),a0
 moveq #$32,d0
 moveq #127,d1
 moveq #40,d2
bra textaus                     * Jetzt Adressen ausgeben

finmenue:                       * Ende einiger Menpunkte
 bsr erakreuz                   * Kreuz mu aus
 clr.b xormode(a5)              * XOR-Mode auf der GDP mu auch aus
 move.b #1,wrtpage(a5)          * Auf Seite 1 schreiben
 bsr aktpage
 clr.b gdpscroll(a5)            * Merken
 lea fimsg(pc),a0
 moveq #$11,d0
 move #430,d1
 moveq #0,d2
 bsr textaus                    * Text ausgeben
 clr.b wrtpage(a5)              * Und auf Seite Null auch
 bsr aktpage
 moveq #$11,d0
 bsr textaus
 btst.b #0,ioflag(a5)
 beq.s fin1m
 clr.b page1.w                  * Nur bei neuer GDP Scroll aus
fin1m:
 bsr ki
 cmp.b #'F',d0                  * 'F' schaltet Flip um
 bne.s fin2m
 tst.b flip(a5)                 * Wenn aus war, dann einschalten
 bne.s fin12m
 move.b #1,flip(a5)             * Schnellste Rate
 move.b #1,flipcnt(a5)          * Zwei-Seiten-Umschaltung
bra.s fin1m                     * Nchste Eingabe abwarten
fin12m:
 clr.b flip(a5)                 * Flip ausschalten
 clr.b viewpage(a5)
 bsr aktpage                    * Seite Null ansehen
bra.s fin1m
fin2m:
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq.s fin3m
 cmp.b #'M',d0                  * 'M' ist Ende
 bne.s fin1m
fin3m:
 clr.b curon(a5)                * Kein Cursor
 clr.b flip(a5)                 * Keine Seitenumschaltung
 clr.b flip1(a5)
 move.b #1,first(a5)            * Turtle auf first
 clr oldsize(a5)                * Keine alte Figur
rts

aendere:                        * Speicherstelle(n) ndern
 lea txta1(pc),a0
 bsr headaclr                   * berschrift
aend0:
 bsr getadr                     * Adresse Ram
 bcs carset                     * Fehler ist Abbruch
 movea.l d0,a4                  * Adresse merken
aend1:
 lea txta2(pc),a0
 moveq #$22,d0
 moveq #10,d1
 moveq #25,d2
 bsr textprint                  * Befehle
aend2:
 lea ausbuf(a5),a0
 movea.l a0,a1                  * Ausbuf-Adresse merken
 move.l a4,d0
 bsr print8x                    * Adresse ausgeben
 move #': ',(a0)+
 movea.l a0,a2
 movea.l a4,a3
 moveq #5-1,d7                  * 5 Werte
aend3a:
 move.b (a3)+,d0
 bsr print2x                    * Hexadezimal
 move #'  ',(a0)+
dbra d7,aend3a
 clr.b (a0)
 movea.l a1,a0
 moveq #$22,d0
 moveq #20,d1
 move #160,d2
 lea ausbuf(a5),a0
 bsr textaus                    * Hex-Ausgabe
 movea.l a2,a0
 movea.l a4,a3
 moveq #5-1,d7                  * 5 Werte
aend3b:
 move.b (a3)+,d0                * Bit 8-15 sind 0 !!
 move.l #'    ',(a0)            * Leerraum fr verschiedene Anzahl Zeichen
 move.l a0,-(a7)                * a0 retten
 bsr print4d                    * Dezimal
 move.b #' ',(a0)               * Endekennung lschen
 movea.l (a7)+,a0               * a0 zurck
 addq.l #4,a0
dbra d7,aend3b
 clr.b (a0)
 movea.l a1,a0
 moveq #$22,d0
 move #140,d2
 bsr textaus                    * Dez-Ausgabe
 movea.l a4,a3
 moveq #5-1,d7                  * 5 Werte
aend3c:
 move.b (a3)+,d0
 bsr putascii                   * ASCII
 move.b d0,(a2)+
 move.b #' ',(a2)+
 move #'  ',(a2)+
dbra d7,aend3c
 clr.b (a2)
 movea.l a1,a0
 moveq #$22,d0
 moveq #120,d2
 bsr textaus                    * ASCII-Ausgabe
 lea einbuf(a5),a0
 clr.b (a0)
 move.l a4,d0                   * Adresse
 btst.b #0,d0
 bne.s aend4                    * Ungerade Adresse, dann kein DIS-Assembler
 bsr trapdisass                 * DIS-Assemblieren
aend4:
 moveq #82-1,d0
aend5:
 move.b (a0)+,(a1)+             * Maximal 82 Zeichen bertragen
dbeq d0,aend5
 subq.l #1,a1                   * Zurck
 tst d0
 bmi.s aend7                    * Wenn Zeile voll, dann weiter
aend6:
 move.b #' ',(a1)+              * Rest mit Leerzeichen fllen
dbra d0,aend6
aend7:
 clr.b (a1)                     * Ende markieren
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #20,d1
 move #105,d2
 bsr textaus                    * Text ausgeben
aend8:
 lea einbuf(a5),a0
 moveq #$22,d0
 moveq #20,d1
 moveq #70,d2
 moveq #35,d3                   * Maximal 35 Zeichen
 bsr textein                    * Befehlseingabe
 bcs carset                     * Abbruch
 tst d4                         * Wenn mindestens 1 Zeichen, dann weiter
 bne.s aend9
 addq.l #1,a4                   * Sonst Adresse+1
bra aend2
aend9:
 cmp #1,d4                      * Mehr als 1 Zeichen, dann weiter
 bne.s aend13
 move.b -(a0),d0                * Das Zeichen holen
 cmp.b #'-',d0                  * '-' = Adresse-1
 bne.s aend10
 subq.l #1,a4
 bra aend2
aend10:
 bsr bucheck
 cmp.b #'R',d0                  * 'R' = neue Adresse
 beq aend0
 cmp.b #'D',d0                  * 'D' = Zum Dump umschalten
 bne.s aend11
 lea txta1(pc),a0
 bsr headaclr                   * Alte berschrift
 move.b #1,wrtpage(a5)
 bsr aktpage                    * Auf beiden Seiten ausgeben
 bsr headaus
 move.l a4,d0
 bsr spdump                     * Dump aufrufen
 bsr speich2                    * Befehle fr Dump
 lea txta1(pc),a0
 bsr headaclr                   * berschrift neu
 move.l a4,d0
 and.b #$f0,d0
 sub.l a3,d0
 suba.l d0,a4                   * Neue Adresse berechnet
bra aend1
aend11:
 cmp.b #'F',d0                  * 'F' = Fllen
 bne.s aend12
 bsr fillspei
bra aend2
aend12:
 cmp.b #'S',d0                  * 'S' = Suchen
 bne.s aend13
 bsr suchwert
 bcs aend8                      * Fehler, nicht gefunden
bra aend2                       * OK, gefunden
aend13:
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq.s *+8
 cmp.b #'M',d0                  * 'M' = Ende
 bne.s aend14
rts
aend14:                         * Wert berechnen und ins Ram
 lea einbuf(a5),a0
 bsr igbn
 cmp.b #$27,(a0)
 bne.s aend15
 bsr.s getstring                * Ist String eingegeben worden ?
 bcs aend8                      * Fehler
bra.s aend16                    * OK, String ausgeben
aend15:
 bsr zuweis                     * Symboldefinition ist erlaubt
 bcc aend8
 bsr wertmfeh                   * Keine Definition, dann Wert ausrechnen
 bcs aend8
 bsr putwert                    * Wert in ausbuf ablegen und d0 vorbereiten
aend16:
 move.l d0,d1                   * Anzahl der Bytes
 bsr fillsp0                    * Speicher fllen
bra aend2                       * Wiederholen


