*******************************************************************************
*                         68008 Grundprogramm menue2                          *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2007 Jens Mewes                                 *
*                                 Rev 7.00                                    *
*                                01.09.2007                                   *
*                 Unterprogramme der Mensteuerung  Teil 2                    *
*******************************************************************************

getstring:                      * Liefert String in ausbuf und d0 = Anzahl Bytes
 addq.l #1,a0                   * ' berspringen
 movea.l a0,a1
getstr1:
 tst.b (a1)+                    * Bis zur Endekennung suchen
 bne.s getstr1                  * Null ist Ende
 subq.l #1,a1                   * Null nicht beachten
getstr2:
 cmp.b #' ',-(a1)
 beq.s getstr2                  * Ende-Leerzeichen ignorieren
 cmp.b #$27,(a1)
 bne carset                     * ' mu am Ende vorhanden sein
 clr.b (a1)                     * ' lschen
 lea ausbuf(a5),a2              * Ziel
 moveq #-1,d0                   * d0 ist ab jetzt Zhler der Zeichen
getstr3:
 addq.l #1,d0                   * Ein Zeichen mehr vorhanden
 move.b (a0)+,(a2)+             * Ablegen
 bne.s getstr3                  * Bis Null
 tst.l d0                       * d0 testen
 beq carset                     * Wenn Null, dann kein String vorhanden
bra carres                      * OK, String ist in Ordnung

getzahl:                        * a0 = Text / liefert Wert in d0.l
 moveq #$22,d0
 moveq #20,d1
 move #190,d2
 bsr textaus                    * Text ausgeben
getzahl1:
 lea einbuf(a5),a0
 moveq #116,d1
 move #190,d2
 moveq #29,d3
 bsr textein                    * Text einlesen
 bcs carset                     * Abbruch
 lea einbuf(a5),a0
 bsr igbn
 cmp.b #$27,(a0)                * Stringeingabe ist jetzt erlaubt
 beq.s getstring
 bsr zuweis                     * Zuweis erlaubt
 bcc.s getzahl1                 * Wenn Zuweis, dann wiederholen
bra wertmfeh                    * Wert holen mit Fehlerbehandlung

zweiwert:                       * Zwei Werte einlesen(In ausbuf steht dann Wert)
 lea txta3(pc),a0               * d0 = Lnge des Wertes/ d1 = Anzahl
 bsr.s getzahl                  * Erster Wert
 bcs carset
 lea einbuf(a5),a0              * Ziel
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #$27,(a0)
 beq carset                     * String ist nicht erlaubt
 tst.l d0                       * Wert darf nicht Null sein
 beq carset
 move.l d0,-(a7)                * Merken
 lea txta4(pc),a0
 bsr.s getzahl                  * Zweiter Wert
 movem.l (a7)+,d2               * Erster Wert zurck
 bcs carset                     * Carry = Fehler
 lea einbuf(a5),a0              * Ziel
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #$27,(a0)                * War ein String eingegeben worden ?
 beq.s zweiw1                   * Ja, dann weiter
 bsr putwert                    * Wert in ausbuf / d0 vorbereiten
zweiw1:
 move.l d2,d1                   * Anzahl der zu bearbeitenden Bytes
rts

fillspei:
 bsr zweiwert                   * Zwei Werte holen
 bcs carset                     * Fehler
fillsp0:                        * In d0 steht Lnge Wert in Bytes
 lea ausbuf(a5),a0              * In d1 steht Anzahl der zu fllenden Bytes
 clr d2                         * In ausbuf steht Wert
fillsp1:
 cmpa.l #1024*1024*cpu-1024-1,a4* 1 Mbyte - 1 KByte IO-Bereich
 bhi carset                     * Wenn grer, dann nicht weiterfllen
 move.b (a0)+,(a4)+             * Wert in Speicher
 subq.l #1,d1                   * Erniedrigen
 beq carres                     * bis alle Werte ausgegeben
 addq #1,d2                     * Nchstes Zeichen in ausbuf
 cmp d0,d2                      * Alle Zeichen durch ?
 bne.s fillsp1                  * Nein, deshalb nchstes Zeichen bertragen
bra.s fillsp0                   * Ja, deshalb von ausbuf an wiederholen

suchwert:                       * Wert suchen
 bsr.s zweiwert                 * Wie bei fillspeich
 bcs carset
 lea 1(a4),a3                   * Ab hier suchen
suchw1:
 lea ausbuf(a5),a0              * Ab hier steht Wert
 move.b (a0)+,d3
suchw2:
 cmpa.l #1024*1024*cpu-1024-1,a3* 1 Mbyte - 1 KByte IO-Bereich
 bhi carset                     * Wenn grer, dann nicht gefunden
 cmp.b (a3)+,d3                 * Erstes Byte suchen
 beq.s suchw3                   * Gefunden
 subq.l #1,d1                   * Weitersuchen
bne.s suchw2                    * OK
bra carset                      * Ende, nicht gefunden
suchw3:
 movea.l a3,a2                  * Rest vergleichen
 clr d2
suchw4:
 addq #1,d2                     * Nchstes Byte
 cmp d0,d2                      * Bis Ende des Suchwertes erreicht ist
 beq.s suchwfi                  * Dann ist Wert gefunden
 cmpm.b (a2)+,(a0)+             * So lange vergleichen, wie Werte gleich sind
 beq.s suchw4                   * Weitersuchen
bra.s suchw1                    * Von vorne beginnen
suchwfi:
 lea -1(a3),a4                  * a4 = Adresse gefunden
bra carres

putwert:                        * In d0 ist Wert
 lea ausbuf(a5),a0              * d1 ist Lnge
 cmp #1,d1                      * Ergebnis d0 = Lnge in Bytes
 bne.s putwert1
 move.b d0,(a0)                 * Byte
 moveq #1,d0                    * 1 Byte
rts
putwert1:
 cmp #2,d1
 bne.s putwert2
 move d0,(a0)                   * Wort
 moveq #2,d0                    * 2 Bytes
rts
putwert2:
 move.l d0,(a0)                 * Langwort
 moveq #4,d0                    * 4 Bytes
rts

suchbibo:                       * Einen oder mehrere Bibliothekseintrge suchen
 cmp #1,d0                      * d0 = 0  Von a0 an suchen
 beq.s suchbibc                 * d1 = 1  Von $400 an suchen
 lea $400,a0                    * In d2 und d3 steht der zu suchende Name
 tst d0                         * d1-d7 enthalten dann Daten Carry = 0
 beq.s suchbibc                 * Sonst Carry = 1
 clr.l (a1)                     * Endekennung setzen
 bsr suchbibf                   * d1 = 2 Alle Eintrge in einer Tabelle von a1
 bcs carset                     * an ablegen / Carry wenn kein Eintrag vorhanden
suchbiba:
 move.l a0,(a1)+                * Adresse Eintrag
 addq.l #4,a0                   * Kennung berspringen
 move.l (a0)+,(a1)+             * Name
 move.l (a0)+,(a1)+             * Name
 move.l (a0)+,d0                * Startadresse
 tst.b 4(a0)
 beq.s suchbibb
 add.l -16(a1),d0               * Relokativ, deshalb Adresse Eintrag addieren
suchbibb:
 move.l d0,(a1)+                * Startadresse ablegen
 move.l (a0)+,(a1)+             * Lnge
 move.w (a0)+,(a1)+             * Relokativ-Flag und CPU
 adda #10,a0                    * Reservierung berspringen
 bsr.s suchbibf                 * Nchsten Eintrag suchen
 bcc.s suchbiba                 * Schleife
 clr.l (a1)                     * Endekennung
bra carres                      * OK, mindestens ein Eintrag gefunden

wandled0:                       * Name (4 Buchstaben) in d0
 rol.l #8,d0                    * Alle Kleinbuchstaben werden in Grobuchstaben
 bsr bucheck                    * gewandelt
 rol.l #8,d0                    * Rest bleibt unverndert
 bsr bucheck
 rol.l #8,d0
 bsr bucheck
 rol.l #8,d0
bra bucheck

suchbibc:
 move.l d2,d0                   * Namen wandeln
 bsr.s wandled0
 exg.l d0,d3
 bsr.s wandled0
 move.l d0,d2                   * Name liegt jetzt in Grobuchstaben vor
suchbibd:
 bsr.s suchbibf                 * Eintrag suchen
 bcs carset                     * Nicht gefunden
 move.l 4(a0),d0
 bsr.s wandled0                 * In Grobuchstaben wandeln
 cmp.l d0,d3                    * Vergleichen
 bne.s suchbibe                 * Falsch
 move.l 8(a0),d0
 bsr.s wandled0                 * In Grobuchstaben wandeln
 cmp.l d0,d2                    * Vergleichen
 bne.s suchbibe                 * Falsch
 move.l a0,d1                   * Adresse Eintrag
 addq.l #4,a0
 movem.l (a0)+,d2-d5            * Daten
 move.b (a0)+,d6                * Relokativ-Flag
 move.b (a0)+,d7                * CPU
 tst.b d6
 beq carres                     * OK, wenn absolut
 add.l d1,d4                    * Relokativ
bra carres                      * OK
suchbibe:
 adda #32,a0                    * Reservierung berspringen
bra.s suchbibd                  * Weiter suchen

suchbibf:
 cmp.l #$55aa0180,(a0)          * Kennung suchen
 beq.s suchbibh
suchbibg:
 move.l a0,d0
 and #$fc00,d0                  * Auf Grenze bringen
 movea.l d0,a0
 adda #$400,a0                  * 1 Kbyte weiter
 cmpa.l #1024*1024*cpu-1024-1,a0* Ende erreicht ? (1 Mbyte -1Kbyte)
 bls.s suchbibf                 * Nein, dann weiter
bra carset
suchbibh:
 btst.b #0,15(a0)               * Sichheitstest
 bne.s suchbibg                 * Wenn ungerade, dann keine Startadresse
 tst.b 20(a0)
 beq.s suchbibi                 * OK, absolut
 cmp.b #1,20(a0)
 bne.s suchbibg                 * Fehler, da auch nicht relokativ
suchbibi:
 tst.b 21(a0)                   * Ohne Kennung
 beq carres
 cmp.b #cpu,21(a0)
 bne.s suchbibg                 * Falsche CPU
bra carres                      * OK

bibo:
 lea einbuf(a5),a6              * Pointer auf Bildanfangsadresse
 move.l #$400,(a6)              * Von $400 an suchen
bibo0:
 lea bibotxt0(pc),a0
 bsr headaclr                   * berschrift ausgeben
 lea bibotxt1(pc),a0
 moveq #$22,d0
 moveq #10,d1
 move #203,d2
 bsr textprint                  * Anzeige-Zeile
 lea bibotxt2(pc),a0
 moveq #$22,d0
 moveq #30,d1
 moveq #20,d2
 bsr textprint                  * Befehls-Zeile
 moveq #'A',d7                  * Kein Eintrag bisher
 moveq #16,d1                   * Anfang der Zeile
 move #188,d2                   * Auf oberste Zeile
 movea.l (a6),a4                * Anfangssuchadresse
 lea ausbuf(a5),a1              * Zieladresse Programmanfnge
bibo1:
 movea.l a4,a0
 bsr suchbibf                   * Eintrag suchen
 movea.l a0,a4
 bcs.s bibo3                    * Keinen gefunden
 moveq #0,d0                    * Nicht Verschiebbar
 lea bibotxt3(pc),a2            * NEIN
 tst.b 20(a4)                   * Null ?
 beq.s bibo2                    * Ja, dann OK
 addq.l #6,a2                   * JA
 move.l a4,d0                   * Verschiebeadresse
bibo2:
 addq.l #4,a4                   * Zeiger auf Name
 lea ausbuf+81(a5),a0           * Ziel fr eine Zeile
 move.b d7,(a0)+                * Auswahlbuchstabe
 move.l #'    ',(a0)+           * Leerraum
 move.l (a4)+,(a0)+             * Name
 move.l (a4)+,(a0)+             * 8 Buchstaben
 move.w #'  ',(a0)+             * Leerraum
 add.l (a4)+,d0                 * Startadresse + Basisadresse (Falls nicht Null)
 move.l d0,(a1)+                * Ablegen
 bsr print6x                    * Und ausgeben
 move #'  ',(a0)+
 move.l (a4)+,d0                * Lnge
 bsr print6x                    * Ausgeben
 move.l #'    ',(a0)+           * Leerraum
 move.l (a2),(a0)+              * JA oder NEIN
 clr.b (a0)                     * Ende
 moveq #$21,d0
 lea ausbuf+81(a5),a0
 bsr textprint                  * Ausgabe einer Zeile ohne Vorlschen
 adda #12,a4                    * Auf eventuellen nchsten Eintrag
 sub #13,d2                     * Eine Zeile tiefer
 addq #1,d7                     * Ein Eintrag mehr vorhanden
 cmp #'M',d7
 bne.s bibo1                    * Wenn noch Platz, dann nchste Zeile
bibo3:
 move.l a4,4(a6)                * Suchadresse nchste Seite
 lea ausbuf+81(a5),a0
 clr.b 1(a0)                    * Nur ein Zeichen
 moveq #$22,d0
 move #306,d1
 moveq #0,d2
 bsr textaus                    * Ausgabe (A- ) = Starten
bibo4:
 bsr ki                         * Zeichen holen und in Grobuchstaben wandeln
 cmp.b #$1b,d0
 beq carres                     * Ende
 cmp.b #'M',d0
 beq carres                     * Ende
 cmp.b #'+',d0                  * Eine Seite weiter ?
 bne.s bibo5                    * Nein
 cmp.l #1024*1024*cpu-1024-1,4(a6) * Wenn schon ganz hinten, dann nicht weiter
 bhi.s bibo4
 addq.l #4,a6                   * Pointer eine Seite weiter
bra bibo0                       * OK, neue Seite aufbauen
bibo5:
 cmp.b #'-',d0                  * Eine Seite zurck ?
 bne.s bibo6                    * Nein
 cmp.l #$400,(a6)               * Schon am Anfang ?
 beq.s bibo4                    * Ja, zurck zur Abfrage
 subq.l #4,a6                   * Pointer zurck
bra bibo0                       * Ausgabe
bibo6:
 cmp.b #'A',d0                  * Bereich 0-
 bmi.s bibo4                    * Zu klein
 cmp.b d7,d0                    * Zu gro ?
 bpl.s bibo4                    * Ja, dann zurck
 lsl #2,d0                      * Mal 4, da Langwort
 lea ausbuf-'A'*4(a5),a0        * Tabellenbeginn
 movea.l 0(a0,d0),a0            * Zieladresse
 bsr clrall                     * Bildschirm lschen
 move.b menflag(a5),-(a7)       * Men-Einstellungen retten
 bclr #7,menflag(a5)            * Ohne Hardcopy
 jsr (a0)                       * Programm aufrufen
 bsr seta5                      * Zur Sicherheit a5 auf alten Wert
 move.b (a7)+,menflag(a5)       * Zurck
bra finmenue                    * Ende

get3par:                        * 3 Werte lesen
 moveq #$22,d0                  * In a0 steht Text mit mindestens 3 Zeilen
 moveq #10,d1
 move #180,d2
 bsr textprint                  * Text ausgeben
 move #150,d1
 moveq #30,d3
 lea einbuf(a5),a0
 bsr textein                    * Ersten Wert holen
 bcs carset                     * Abbruch
 lea einbuf(a5),a0
 bsr wertmfeh                   * Berechnen mit Fehlerbehandlung
 bcs carset
 move.l d0,d6                   * d6 = erster Wert
get3rest:
 moveq #$22,d0
 move #150,d1
 move #160,d2
 moveq #30,d3
 lea einbuf(a5),a0
 bsr textein                    * Zweiten Wert holen
 bcs carset                     * Abbruch
 lea einbuf(a5),a0
 bsr wertmfeh                   * Wert mit Fehlerbehandlung
 bcs carset
 move.l d0,d7                   * d7 = Zweiter Wert
 moveq #$22,d0
 move #150,d1
 move #140,d2
 moveq #30,d3
 lea einbuf(a5),a0
bra textein                     * In einbuf steht dritter Wert oder Name

get2par:                        * Zwei Werte holen
 moveq #$22,d0
 moveq #10,d1
 move #160,d2
 bsr textprint                  * Text ausgeben
bra.s get3rest                  * Die zwei letzen Werte von get3par holen

startex:                        * Programm starten
 lea stmsg1(pc),a0
 bsr headaclr                   * berschrift
 bsr.s getadr                   * Adresse holen
 bcs carset                     * Fehler
 movea.l d0,a0                  * Startadresse
 bsr clrall                     * Bildschirm lschen
 move.b #1,first(a5)            * Turtle erster Aufruf
 move.b #1,turdo(a5)            * Turtle down
 move.b menflag(a5),-(a7)       * menflag merken
 bclr.b #7,menflag(a5)          * Grundprogramm ausgeschaltet (Hardcopy bei ci)
 jsr (a0)                       * Programm aufrufen
 bsr seta5                      * a5 wieder in Ordnung bringen, falls zerstrt
 move.b (a7)+,menflag(a5)       * menflag zurck
bra finmenue

getadr:                         * Adresse lesen
 lea adrmsg(pc),a0
 moveq #$22,d0
 moveq #20,d1
 move #190,d2
 bsr textaus                    * Aufforderung ausgeben
get1padr:
 lea einbuf(a5),a0
 moveq #$22,d0
 moveq #80,d1
 move #190,d2
 moveq #32,d3
 bsr textein                    * Text lesen
 bcs carset                     * Abbruch
 lea einbuf(a5),a0
 bsr zuweis                     * Zuweis ausfhren
 bcc.s get1padr                 * OK Symbol zugewiesen, neuen Wert lesen
bra wertmfeh                    * Kein Symbol, also Wert berechnen

putascii:                       * ASCII-Wert testen und nach d0 oder '.'
 tst.b d0
 bpl.s putasc3                  * Positiv, dann kein Sonderzeichen
 movem.l d7/a0,-(a7)            * Sonderzeichen
 lea ztab0(pc),a0               * Dort sind Zeichen
 moveq #anztab-2-1,d7           * Anzahl der Zeichen
putasc1:
 cmp.b (a0)+,d0                 * Vergleichen
 beq.s putasc2                  * OK, gefunden
dbra d7,putasc1
 moveq #'.',d0                  * Nicht gefunden also '.'
putasc2:
 movem.l (a7)+,d7/a0
rts                             * Ende Sonderzeichenauswertung
putasc3:
 cmp.b #32,d0                   * Kein Sonderzeichen
 bpl.s putasc4                  * Grer als 32, dann OK
 moveq #'.',d0                  * Kleiner, also CTRL-Zeichen
putasc4:
rts                             * Ende

speicheraus:                    * Speicher ansehen
 lea spmsg1(pc),a0
 bsr headaclr                   * berschrift ausgeben
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * Andere Seite
 bsr headaus                    * Auch dort ausgeben
speich1:
 move.b viewpage(a5),wrtpage(a5)* Leseseite = Schreibseite
 bsr aktpage
 bsr.s getadr                   * Adresse lesen
 bcs carset                     * Fehler
 bsr spdump                     * Dump ausgeben
speich2:
 bsr ki                         * Zeichen von Tastatur holen
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq carset
 cmp.b #'M',d0                  * 'M' ist Ende
 beq carset
 cmp.b #'R',d0                  * 'R' = neue Adresse
 bne.s speich3
 bsr marke0                     * Alte Marke lschen
bra.s speich1                   * Ausgeben
speich3:
 bsr.s speich4                  * Auswertung Rest
bra.s speich2                   * Wiederholen

speich4:
 cmp.b #'+',d0                  * Halbe Seite vor
 bne.s speich5
 bsr marke0                     * Alte Marke weg
 adda #$40,a3                   * Neue Adresse
bra spdump1                     * Dump ausgeben
speich5:
 cmp.b #'-',d0                  * Halbe Seite zurck
 bne.s speich6
 bsr marke0                     * Alte Marke weg
 suba #$40,a3                   * Neue Adresse
bra spdump1                     * Dump ausgeben
speich6:
 cmp.b #'S',d0                  * Suchen
 bne.s speich7
 bsr marke1                     * Alte Marke weg
 bsr suchwert                   * Wert suchen
 move.l a4,d0                   * Neue Adresse, wenn gefunden
bra spdump                      * Dump ausgeben
speich7:
 cmp.b #'F',d0                  * Speicher fllen
 bne.s speich8
 bsr marke1                     * Alte Marke weg
 bsr fillspei                   * Speicher fllen
 move.l a4,d0                   * Neue Adresse
bra spdump                      * Dump ausgeben
speich8:
 cmp.b #'1',d0
 bne.s speich9                  * Ein Byte neu eingeben
 bsr spadr                      * Adresse holen und Wert berechnen
 bcs.s speich8a                 * Fehler = Ende
 bsr spdump                     * Dump, da neue Adresse
 moveq #0,d7                    * Bearbeitung mit Textein (1 mit Readaus)
 bsr.s speich8b                 * Marke eingeben
speich8a:
 move.l a4,d0                   * Neue Adresse
bra spdump                      * Dump neu

speich8b:                       * Ein Byte neu oder ndern (d7 = Typ)
 bsr marke1                     * Marke lschen
 addq #6,d1                     * d1 = X-Position Byte
 lea einbuf(a5),a0
 move.b #'$',(a0)+              * Eingabe als Hexadezimalwert
 move.b (a4),d0                 * Alten Wert
 bsr print2x                    * holen und ablegen
 subq.l #2,a0                   * Alte Adresse
 moveq #$11,d0                  * Gre
 tst d7
 bne.s speich8c
 moveq #3,d3                    * Neu eingeben, deshalb textein
 bsr textein
bra.s speich8d                  * Weiter
speich8c:
 moveq #0,d3                    * ndern, deshalb readaus
 bsr readaus
speich8d:
 add #12,d1                     * Position drittes Zeichen
 bsr moveto                     * Positionieren
 bsr erapen                     * Auf Lschen
 move.b #10,(a6)                * Eventuell vorhandenes drittes Zeichen lschen
 lea einbuf+1(a5),a0
 cmp.b #$27,(a0)                * Wenn ', dann ASCII-Zeichen Eingabe
 beq.s speich8e
 subq.l #1,a0                   * sonst mit '$'
speich8e:
 bsr wertmfeh                   * Wert mit Fehleranalyse
 bcs.s speich8f                 * Fehler
 move.b d0,(a4)                 * Sonst abspeichern
speich8f:
 addq.l #1,a4                   * Neue Adresse
rts

speich9:
 cmp #'2',d0
 bne.s speich10                 * Byte ndern
 bsr.s spadr                    * Adresse holen
 bcs.s speich8a                 * Fehler
 bsr spdump                     * Dump, da neue Adresse
 moveq #1,d7                    * Flag fr ndern
 bsr.s speich8b                 * Byte ndern
bra.s speich8a                  * Ende mit Adressneueinstellung

speich10:
 cmp.b #'3',d0
 bne.s speich11                 * 16 Bytes neu eingeben
 bsr.s spadr                    * Adresse holen
 bcs.s speich8a                 * Fehler
 moveq #0,d7                    * Merker fr eingeben
spei10a:
 and.b #$f0,d0                  * Adresse mu auf 16 Byte-Adresse liegen
 moveq #16-1,d1                 * 16 Bytes eingeben
spei10b:
 movem.l d0/d1/d7,-(a7)
 move d7,-(a7)                  * d7 merken
 bsr spdump                     * Dump ausgeben
 move (a7)+,d7                  * d7 zurck
 bsr speich8b                   * Byte neu eingeben
 movem.l (a7)+,d0/d1/d7
 addq.l #1,d0                   * Nchste Adresse
dbra d1,spei10b
bra spdump                      * Am Ende nochmals Dump

speich11:
 cmp.b #'4',d0
 bne carset                     * 16 Bytes ndern
 bsr.s spadr                    * Adresse holen
 bcs speich8a                   * Fehler
 moveq #1,d7                    * Merker fr ndern
bra.s spei10a                   * Ausfhren

spadr:
 bsr.s marke1                   * Marke lschen
 bsr getadr                     * Adresse holen
 bcc carres                     * OK, alles klar
 lea einbuf(a5),a0
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'=',(a0)+
 bne carset                     * Kein '=', dann Fehler
 bsr igbn                       * Leerzeichen ignorieren
 tst.b (a0)                     * Null mu danach kommen
 bne carset
 move.l a4,d0                   * '=' bedeutet alte Adresse
bra carres

marke0:
 bsr.s marke1                   * Marke weg
 eori.b #1,wrtpage(a5)          * Neue Schreibseite
bra aktpage                     * Und umschalten

marke1:
 bsr erapen                     * Auf Lschen
marke:
 move.l a4,d1                   * Adresse
 sub.l a3,d1                    * Seitenanfangsadresse
 bmi carset                     * Negativ, dann keine Marke vorhanden
 cmp.l #16*8,d1
 bpl carset                     * Auch nicht vorhanden
 move d1,d2
 lsr #4,d2                      * Durch 16, wegen Zeile (16 Byte pro Zeile)
 muls #-20,d2                   * Hhe berechnen
 add #160,d2                    * Hier oberste Zeile
 and #$f,d1                     * Berechnung X-Position
 mulu #24,d1                    * Abstand zwischen zwei Bytes
 add #54,d1                     * Anfangs X-Position
 bsr moveto                     * Positionieren
 move.b #'>',(a6)               * Marke ausgeben
rts

spdump:                         * Dump durchfhren
 movea.l d0,a4                  * d0 = Anfangsadresse
 and.b #$f0,d0                  * Zeilenanfangsadresse
 movea.l d0,a3                  * Merken
 lea spmsg2(pc),a0
 moveq #$22,d0
 moveq #20,d1
 move #190,d2
 bsr textaus                    * berschrift
 lea spmsg3(pc),a0
 moveq #$21,d0
 moveq #0,d1
 move #175,d2
 bsr textprint                  * Byte-Einteilung
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * Das gleiche auch auf Seite 1
 moveq #$21,d0
 bsr textprint
 lea spmsg2(pc),a0
 moveq #$22,d0
 moveq #20,d1
 move #190,d2
 bsr textaus
spdump1:
 bsr wait                       * Hier beginnt Dump
 lea gdp.w,a6                   * GDP-Basis-Register
 lea gdp+9*cpu.w,a2             * X-Register (Low Byte)
 moveq #2,d7                    * WAIT-Bit
 move.w #160,gdp+$a*cpu.w       * ==> Nur fr 68008
 bsr erapen                     * Auf Lschen
 move.b #$11,gdp+3*cpu.w        * Schriftgre einstellen
 moveq #8-1,d5                  * 8 Reihen
spdump2:
 btst.b d7,(a6)                 * Ohne Sprung zu wait schneller
 beq.s spdump2
 move.b #$d,(a6)                * Anfangs X-Position
 moveq #10,d0
 bsr clr8                       * 8 Zeichen lschen
 add.b #12,(a2)                 * 2 Zeichen Platz lassen
 moveq #16-1,d4                 * 16 Zeichen
spdump3:
 btst.b d7,(a6)
 beq.s spdump3
 move.b d0,(a6)                 * 2 Zeichen lschen
spdump3a:
 btst.b d7,(a6)
 beq.s spdump3a
 move.b d0,(a6)
spdump3b:
 btst.b d7,(a6)                 * Ohne Sprung zu wait schneller
 beq.s spdump3b
 add.b #12,(a2)                 * 2 Zeichen Platz lassen
dbra d4,spdump3
 bsr clr8                       * Wieder 8 Zeichen lschen
 move.b #$d,(a6)                * X-Anfangsposition
 sub.b #10,gdp+$b*cpu.w         * Eine Zeile runter
 bsr clr8                       * 8 Zeichen lschen
 add.b #12,(a2)                 * 2 Zeichen frei
 moveq #16-1,d4                 * 16 Zeichen
spdump4:
 btst.b d7,(a6)
 beq.s spdump4
 move.b d0,(a6)                 * Lschen
spdump4a:
 btst.b d7,(a6)                 * Ohne Sprung zu wait schneller
 beq.s spdump4a
 add.b #18,(a2)                 * 3 Zeichen frei
dbra d4,spdump4
 bsr clr8                       * Dann wieder 8 lschen
 sub.b #10,gdp+$b*cpu.w         * Eine Zeile tiefer
dbra d5,spdump2
 bsr setpen                     * Auf Schreiben
 move.b #160,gdp+$b*cpu.w       * Oberste Zeile
 lea prttab(pc),a1              * Zeichen fr HEX-ASCII-Umwandlung
 moveq #8-1,d5                  * 8 Zeilen
spdump5:
 move.b #$d,(a6)                * X - Anfang
 move.l a3,d0                   * Zeilenanfangsadresse
 bsr set8                       * ausgeben
 moveq #0,d0                    * Fr Prfsummenbildung
 moveq #0,d3                    * Ebenfalls
 moveq #16-1,d4
spdump6:
 move.b (a3)+,d3                * Wert holen
 add.l d3,d0                    * Prfsumme bilden
 move.b d3,d2
 lsr #4,d2
 and #$f,d2                     * Vorderen vier Bits
spdump6a:
 btst.b d7,(a6)                 * Ohne Sprung zu wait schenller
 beq.s spdump6a
 add.b #12,(a2)                 * 2 Zeichen Platz lassen
 move.b 0(a1,d2),(a6)           * Bits als Ascii-Zeichen ausgeben
 and #$f,d3                     * Restlichen vier Bits
spdump6b:
 btst.b d7,(a6)                 * Ohne Sprung schneller
 beq.s spdump6b
 move.b 0(a1,d3),(a6)           * Jetzt ausgeben
dbra d4,spdump6
 move.l d0,d6                   * Prfsumme merken
spdump7:
 btst.b d7,(a6)                 * Ohne Sprung schneller
 beq.s spdump7
 add.b #12,(a2)                 * 2 Zeichen Platz
 bsr.s set8                     * 8 Zeichen ausgeben
 sub.b #10,gdp+$b*cpu.w         * Eine Zeile runter
 move.b #$d,(a6)                * X auf Null fr nchste Zeile
 suba #16,a3                    * a3 auf letzten Wert
 move.l a3,d0
 bsr.s set8                     * 8 Zeichen ausgeben (Adresse)
 add.b #12,(a2)                 * 2 Zeichen frei
 moveq #16-1,d4
spdump8:
 move.b (a3)+,d0                * Zeichen holen
 bsr putascii                   * In Ascii wandeln
 bsr cmdput                     * Und ausgeben mit Sonderzeichen
spdump9:
 btst.b d7,(a6)
 beq.s spdump9                  * Ohne Sprung zu wait schneller
 add.b #18,(a2)                 * 3 Zeichen frei
dbra d4,spdump8
 move.l d6,d0                   * Prfsumme holen
 bsr.s set8                     * 8 Zeichen ausgeben
 sub.b #10,gdp+$b*cpu.w         * Eine Zeile runter
dbra d5,spdump5
 suba.l #16*8,a3                * Anfangsadresse Seite
 bsr marke                      * Marke setzen
 move.b wrtpage(a5),viewpage(a5)
bra aktpage                     * Seite sichtbar machen

set8:                           * 8 Zeichen ausgeben
 moveq #8-1,d3
set8a:
 rol.l #4,d0
 move.b d0,d2
 and #$f,d2                     * Nur 4 Bits
set8b:
 btst.b d7,(a6)
 beq.s set8b                    * Ohne Sprung zu wait schneller
 move.b 0(a1,d2),(a6)           * 4 Bits in ASCII ausgeben
dbra d3,set8a
set8c:
 btst.b d7,(a6)                 * Ohne Sprung zu wait schneller
 beq.s set8c
rts

clr8:                           * 8 Zeichen lschen
 moveq #8-1,d3                  * In d0 steht Zeichen zum Lschen
clr8a:
 btst.b d7,(a6)
 beq.s clr8a
 move.b d0,(a6)                 * Zeichen an GDP
dbra d3,clr8a
clr8b:
 btst.b d7,(a6)                 * Ohne Sprung zu wair schneller
 beq.s clr8b
rts

headaclr:                       * berschrift ausgeben (a0=Adresse)
 bsr clrall                     * Screen lschen
headaus:                        * Ohne Lschen
 moveq #$33,d0                  * Gre
 move #225,d2                   * Y-Position
bra centertxt                   * Mittig positionieren und ausgeben

vekdef:                         * Fr Anwendervektoren
 jmp intlvx-basis               * Sprungbefehle werden auf Adressen
 jmp intlvx-basis               * geschrieben, die fr Benutzeranwendungen
 jmp traperr-basis              * reserviert sind
 jmp trap0a-basis
 jmp ciin-basis
 jmp cstsin-basis
 jmp co-basis

linedef:                        * Auch hier, blo sind dies Ausnahmebedingungen
 jmp trap1a-basis
 jmp lineaer-basis
 jmp linefer-basis

mausdef:                        * Eingabegert initialisieren
 jmp mausaus0-basis
 jmp absmaus0-basis

exinit:                         * Init der Variablen und Init a5/a7
 bsr seta5                      * a5 setzen
init:                           * Internes Init
 movem.l d0-d7/a0-a7,regsave(a5)
 bsr flinit                     * Floppy-Init am Anfang wegen Floppy-Motor
 move.b keys.w,keydil(a5)       * Stellung der DIL-Schalter merken
 bsr uhrinit                    * UHR-Init, muss zu Anfang wg. NVRAM
 cmp.b #3, uhrausw(a5)
 bne.s init01
 lea nvrbuff(a5), a0
 clr (a0)
 bsr getsys
 tst d0
 bne.s init01                   * NVRAM Daten nicht korrekt
 lea nvrbuff(a5), a0
 move #$a5c3, (a0)              * als Kennung, dass Daten gelesen
 move.b 2(a0), keydil(a5)       * DIP-Key berschreiben
init01: 
 bsr srdinit                    * SRAMDISK initialisieren
 bsr erakreuz                   * Fadenkreuz ausschalten
 move.b #%01000000,proma2.w     * Promer neutral stellen (Bei Promer2 egal)
 clr.b proma5.w                 * Promer2 neutral stellen (Bei Promer egal)
 clr.b iodir(a5)                * Kein CTRL-A bei CO2
 clr oldsize(a5)                * Keine alte Figur gltig
 clr.b synstate(a5)             * Kein Syncrol-Impuls abgefragt
 clr.b flip(a5)                 * Keine Seitenumschaltung
 clr.b flip1(a5)
 clr.b color(a5)                * Farbe fr GDP
 clr.b xormode(a5)              * Kein Verknpfungsmode
 clr tur1x(a5)                  * Turtle auf Null
 clr tur1y(a5)
 clr tur1phi(a5)                * Winkel auf Null
 clr turx(a5)
 clr tury(a5)
 clr turphi(a5)
 move.b #1,turdo(a5)            * Turtle down
 move.b #1,first(a5)            * Turtle erster Aufruf
 move.b #1,iostat(a5)           * Nur Fehlerausgabe
 clr.b serflag(a5)              * Serielle Schnittstelle nicht ansprechen
 move.b #2,iostatb(a5)          * ci/csts/ci2 nicht umlenken
 move #2,passflag(a5)           * Ausgabe bei CO2 eingeschaltet
 move #2,errflag(a5)            * Ausgabe bei CO2, nur Fehlerausgabe bei ASS
 clr.b curon(a5)                * Cursor bei CO2 an
 clr.b escmerker(a5)            * Kein ESC bei CO
 tas.b menflag(a5)              * Nach Reset wieder mit Hardcopy
 bclr.b #2,menflag(a5)          * Grundprogramm nicht als Aufruf
 move.b #%00000101,tracflag(a5) * Mit Regdump / TRAP+JSR Direktausfhrung
                                * Ohne Listen
 clr.b coscroll(a5)             * Scroll immer auf Null stellen
 clr.b page1.w                  * Kein Scroll bisher

init1:
 lea basis(pc),a0
 move.l a0,d1
 beq.s init3                    * Grundprogramm auf Null, dann keine Exception
                                * bertragen
 suba.l a1,a1                   * Zieladresse = 0
 move #$100-1,d2                * $100 Langworte bertragen
init2:
 move.l (a0)+,(a1)              * Wert bertragen
 add.l d1,(a1)+                 * Adresse addieren
dbra d2,init2
init3:
 cmp.l #$a140557a,poweron(a5)   * Wenn Power an, dann Ende
 beq getstack                   * Stack nach d0
 bsr clrall                     * Bildschirm lschen
 bsr setpen                     * Schreiben
 lea copyr(pc),a0               * Copyright nur einmal am Anfang ausgeben
 moveq #$00,d0
 moveq #100,d2
 bsr centertxt                  * Copyright ausgeben

 lea copyr2(pc),a0
 moveq #$33,d0
 moveq #60,d2
 bsr centertxt

 lea copyr3(pc),a0
 moveq #$11,d0
 moveq #20,d2
 bsr centertxt

 moveq #15,d0                   * 1,5 Sekunden
 bsr delay                      * warten
 lea $1000(a5),a0               * Adresse fr Editor
 move.l a0,stxtxt(a5)           * Anfang
 move.l a0,akttxt(a5)           * und Aktuell
 move.l a0,etxtxt(a5)           * und Ende
 clr.b (a0)                     * Endekennung
 clr.b lrand(a5)                * Linker Rand im Editor auf Null
 clr.b insl(a5)                 * Voreinstellungen Editor
 lea $1c00(a5),a0               * Voreinstellung fr Assembler
 move.l a0,pcorg(a5)
 clr.b debug(a5)                * Debug aus
 move.b #$11,groesse(a5)        * Schriftgre gleich auf 80 Zeichen
 clr.b cotempo(a5)              * Scoftware-Scroll bei co2-Ausgabe
 bsr editeiin                   * Init Tabulatoren
 bsr editem                     * Init Macros
 move.b #5,akteprom(a5)         * Promers 2764 voreingestellt
 lea vekdef(pc),a0              * Anwendervektoren
 lea vekdest(a5),a1             * Ziel
 lea basis(pc),a2               * Additionsadresse
 move.l a2,d1
 moveq #7-1,d2                  * 7 Werte
init4:
 move (a0)+,(a1)+               * JMP-Befehle bertragen
 move.l (a0)+,(a1)
 add.l d1,(a1)+                 * Basis addieren
dbra d2,init4
 lea linedef(pc),a0
 lea trap1(a5),a1               * Jetzt trap1a, linea + linef definieren
 moveq #3-1,d2
init5:
 move (a0)+,(a1)+
 move.l (a0)+,(a1)
 add.l d1,(a1)+
dbra d2,init5
 lea mausdef(pc),a0
 lea mausadr0(a5),a1
 moveq #2-1,d2                  * Jetzt Eingabegert (Maus)
init6:
 move (a0)+,(a1)+
 move.l (a0)+,(a1)
 add.l d1,(a1)+
dbra d2,init6                   * bertragung aller Vektoren abgeschlossen
 move.b keydil(a5),d1           * DIL-Schalter holen
 move.b #$80,d0                 * Bit 7 setzen
 move.b d0,menflag(a5)          * 
 lsr #3,d1                      * Bit 3 auf Bit 0
 and.b #1,d1                    * Nur Bit 0 lassen
 clr.b aktser(a5)
 move.b #$1e,ser3.w             * Standarteinstellung SER
 move.b #$0b,ser2.w
 cmp.b #$1e,ser3.w
 bne.s init6a                   * Nicht vorhanden
 cmp.b #$0b,ser2.w
 bne.s init6a                   * Nicht vorhanden
 addq.b #4,d1                   * SER ist vorhanden
 move.b #1, aktser(a5)          * SER ist aktueller Kanal
 lea nvrbuff(a5), a0
 cmp #$a5c3, (a0)               * NVRAM Daten?
 bne.s init6a                   * nein
 move.b 8(a0), d0
 move.b 9(a0), d1
 bsr siinit
init6a:
 move.b ser2c.w, d0             * Interrupt Vector Reg SER2
 cmp.b #$0f, d0                 * Startwert nach RESET
 bne.s init7                    * keine SER2
 move.b #$5a, ser2c.w           * Testwert
 cmp.b #$5a, ser2c.w            * ist drinn?
 bne.s init7                    * nein, doch keinen SER2
 move.b d0, ser2c.w             * wieder herstellen
 move.b #$10, d0                * SER2 Kanal A initialisieren
 lea nvrbuff(a5), a0
 cmp #$a5c3, (a0)               * NVRAM Daten?
 bne.s init6b                   * nein
 adda.l #10, a0                 * Auf SER2 Kanal A
 bra.s init6c
init6b:
 lea s2bd9600(pc), a0           * 9600,E,8,1
init6c:
 bsr siinit
 move.b #$11, d0                * SER2 Kanal B initialisieren
 lea nvrbuff(a5), a0
 cmp #$a5c3, (a0)               * NVRAM Daten?
 bne.s init6d                   * nein
 adda.l #16, a0                 * Auf SER2 Kanal B
 bra.s init6e
init6d:
 lea s2bd9600(pc), a0           * 9600,E,8,1
init6e:
 bsr siinit
 bset.b #3, d1                  * SER2-Bit
 tst.b aktser(a5)               * schon ne SER da?
 bne.s init7                    * jo, dann weiter
 move.b #2, aktser(a5)          * sonst Kanal A der SER2 aktuell
 move.b $01, ser2f.w            * LED Kanal A an
init7:
 move.b d1,ioflag(a5)           * Bit0=GDP-Vers., Bit2=SER, Bit3=SER2
 move.b #1,optflag(a5)          * Deutscher Zeichensatz an
 move.b #2,dflag0(a5)           * Druckerinit nur einmal (Deutscher Zeichensatz)
 clr.b dflag1(a5)
 move.b #65,dflag2(a5)          * Zeilen pro Seite
 clr.b dflag3(a5)               * Linker Rand
 st drsave(a5)                  * Keine selbstdefinierten Befehle
                                * Init fr Grafik-Paket
 clr.b grafflag(a5)             * Als Grafik-Karte ist GDP eingestellt
 clr.b gdpvpage(a5)             * Leseseite
 clr.b gdpwpage(a5)             * und Schreibseite auf Null
 clr.b gdpscroll(a5)            * Kein Scroll bisher
 clr.b gdpxor(a5)               * Kein XOR-Mode
 move.b #1,gdpcolor(a5)         * Farbe ist wei
 move.l #$ec000,colram(a5)      * Adresse der Ram-Karte der COL einstellen
 clr.b colvpage(a5)             * COL-Seiten auch auf Null
 move.b #$80,colwpage(a5)       * Karte eingeschaltet nach erstem Aufruf
 clr colscroll(a5)              * Kein Scroll bei der COL-Karte
 bsr colinit_                   * COL initialisieren (Hilfslabel)
 moveq #1,d1                    * Farbe auf wei
 clr d2                         * Auf Setzen
 bsr gr2p15_                    * Wieder GRAFIK aufrufen (Hilfslabel)
 clr.b grafflag(a5)             * Wieder GDP einschalten
 bsr clutinit                   * CLUT auf Standartwerte einstellen
 bsr mausaus                    * Maus rcksetzen
 bsr drbefinit                  * Drucker-Befehle ins Ram kopieren
 bsr casinit                    * Kassetteninterface ein
 bsr loinit                     * Drucker init
 bsr ciinit2                    * ci2 init
 bsr mausaus                    * Maus rcksetzen
 bsr symloesche
 move.l #$a140557a,poweron(a5)  * Power ist an
bra getstack                    * Stack in d0 zurckliefern

getstx:                         * Adresse Editor holen
 move.l stxtxt(a5),d0
rts

putstx:                         * Adresse Editor setzen
 move.l d0,stxtxt(a5)
 move.l d0,akttxt(a5)
 movea.l d0,a0                  * Adresse nach a0
put1stx:
 tst.b (a0)+                    * Bis Null gefunden
 bne.s put1stx
 subq.l #1,a0                   * 1 Byte zurck
 move.l a0,etxtxt(a5)           * Ende gesetzt
rts

setxor:                         * XOR-Mode fr GDP setzen
 and.b #$f,d0
 move.b d0,xormode(a5)
bra aktpage                     * Aktuelle Seite setzen und XOR-Mode

getxor:                         * XOR-Mode nach d0
 moveq #0,d0
 move.b xormode(a5),d0
rts

setcolor:                       * Farbe setzen
 move.b d0,color(a5)            * Farbe merken
bra aktpage                     * Seite und Farbe setzen

getcolor:                       * Farbe holen
 moveq #0,d0
 move.b color(a5),d0
rts

curonein:                       * Cursor einschalten
 move.b #1,curon(a5)
rts

curonaus:                       * Cursor ausschalten
 clr.b curon(a5)
rts

getbasis:                       * Basisadresse Grundprogramm laden
 lea basis(pc),a0
 move.l a0,d0
rts

getvar:                         * Variablenadresse laden
 lea basis(pc),a0
 adda.l ramstart(pc),a0
 move.l a0,d0
rts

seta5:                          * a5 neu setzen
 lea basis(pc),a5
 adda.l ramstart(pc),a5
rts

getfrei:                        * Adresse hinter Symboltabelle ermitteln
 lea    symtab+symlen(a5),a0
 bsr.s  getnext
 adda.l d0,a0                   * Ende Symboltabelle + Sicherheitsabstand
rts

getsymtab:                      * Adresse Symboltabelle holen
 lea symtab(a5),a0
 move.l a0,d0
rts

getnext:                        * Lnge Symboltabelle holen
 moveq #0,d0
 move symnext(a5),d0
rts

putnext:                        * Adresse fr nchsten Symboltabelleneintrag
 move d0,symnext(a5)            * setzen
rts

getvers:                        * Versionsnummer laden
 move.l versnum(pc),d0
rts

getsn:                          * Seriennummer laden
 move.l snnum(pc),d0
rts

getorg:                         * Assemblerzieladresse holen
 move.l pcorg(a5),d0
rts

putorg:                         * Adresse setzen
 move.l d0,pcorg(a5)
rts

crtex:                          * Ausgabe auf Screen
 move.b #2,iostat(a5)
rts

lstex:                          * Ausgabe auf Drucker
 move.b #3,iostat(a5)
rts

usrex:                          * Ausgabe auf Benutzervektor
 move.b #5,iostat(a5)
rts

serex:                          * co2 auf serielle Karte umlenken
 btst.b #2,ioflag(a5)           * SER?
 bne.s serex1
 btst.b #3,ioflag(a5)           * SER2?
 beq carset                     * Keine SER vorhanden
serex1:
 move.b #6,iostat(a5)
bra carres                      * OK

nilex:                          * Ausgabe ins Leere
 clr errflag(a5)
erraus:                         * Nur Fehlerausgabe
 move.b #1,iostat(a5)
rts

seraus:                         * Umlenkung auf serielle Karte
 btst.b #2,ioflag(a5)           * SER?
 bne.s seraus1
 btst.b #3,ioflag(a5)           * SER2?
 beq carset                     * Keine Umschaltung, wenn keine SER vorhanden
seraus1:
 move.b d0,serflag(a5)
bra carres                      * OK

seterr:                         * Fehlerflag setzen
 move d0,errflag(a5)
rts

geterr:                         * Fehlerflag holen
 move errflag(a5),d0
rts

setpass:                        * Passflag setzen
 move d0,passflag(a5)
rts

gdpvers:                        * GDP-Version abfragen
 moveq #0,d0
 move.b ioflag(a5),d0           * 0 = Alte GDP / 1 = Neue GDP
 and.b #1,d0
rts

asserr:                         * Fehleranzahl nach d0.l
 moveq #0,d0                    * Wort innerhalb eines Langwortes
 move errcnt(a5),d0
rts

getcurxy:                       * Cursor Position nach d1.l / d2.l
 moveq #0,d1                    * Byte innerhalb Langwort
 moveq #0,d2
 move.b curx(a5),d1
 move.b cury(a5),d2
rts

setcurxy:                       * Neuer Cursor d1=curx d2=cury
 movem.l d1-d2,-(a7)
 move.b d1,curx(a5)
 move.b d2,cury(a5)
 bsr aktcur                     * Cursor mit neuen Werten setzen
 movem.l (a7)+,d1-d2
rts

setflip:                        * Seitenumschaltung
 move.b d0,flip(a5)             * d0 = flip0
 move.b d0,flipcnt(a5)          * Doppelseite
 move.b d1,flip1(a5)            * d1 = flip1
 move.b d1,flip1cnt(a5)         * Viererseite
rts

setgroe:                        * Setzt Zeichengre fr co2 etc.
 move.b d0,groesse(a5)          * Gre $11 und $21 sinnvoll
 move d0,-(a7)                  * Andere sind denkbar
 and #$f,d0                     * Y-Vergrerung lassen
 cmp #1,d0                      * 1 ?
 beq.s setgroe1                 * Ja, dann OK
 clr.b cotempo(a5)              * Sonst nur Software-Scroll erlaubt
setgroe1:                       * ACHTUNG !!!
 move (a7)+,d0                  * Dieses Programm darf nicht whrend der CO2-
rts                             * Ausgabe benutzt werden


*********************** Diskettenfunktionen unter JADOS ***********************
*      Hier ndern, wenn an anderes Betriebssystem angepasst werden soll      *
*                            Siehe auch edit2.asm                             *
*******************************************************************************

savedisk:                       * Daten auf Disk speichern
 bsr    dostest
 bcs    carset
 lea    menue31(pc),a0
 bsr    menueio
 cmp.b  #'1',d0
 beq.s  savedatei
 cmp.b  #'2',d0
 beq.s  saveedit                * Editordaten speichern
 cmp.b  #'3',d0
 beq    savedruck               * Druckerdaten speichern
rts

savedatei:                      * Datei speichern
 lea    sadadt0(pc),a0
 lea    sadadt1(pc),a1
 move   #180,d3
 bsr    doswerte
 bcs    carset
 bsr    fillfcb                 * Namen eintragen
 bcs    doserr0
 lea    sadadt2(pc),a0
 moveq  #115,d2
 bsr    doswert0
 bcs    carset
 bsr    wertmfeh
 bcs    carset
 movea.l d0,a2                  * Quelladresse merken
 lea    sadadt3(pc),a0
 moveq  #50,d2
 bsr    doswert0
 bcs    carset
 bsr    wertmfeh
 bcs    carset
 subq   #1,d0                   * Anzahl Sektoren minus 1
 move   d0,d1
 lea    einbuf+40(a5),a1
 movea.l a2,a0
 bsr    filesave                * JADOS-Funktion
bra     doserr

saveedit:
 lea    saeddt0(pc),a0          * berschrift
 lea    saeddt1(pc),a1          * Frage-Text
 moveq  #125,d3                 * Y-Koordinate
 bsr    doswerte                * Namen holen
 bcs    carset
saveed0:
 bsr    fillfcb
 bcs    doserr0                 * a1 = Buffer
 bsr    getfrei
 movea.l a0,a2
 move.l #'RDED',(a2)+
 move.l #'ITOR',(a2)+           * Kennung, da es Editordaten sind
 move.b groesse(a5),(a2)+       * Ausgabegre
 move.b insl(a5),d0
 and.b  #%00011001,d0
 move.b d0,(a2)+                * Einfgemode, Scroll-Art, Anfangsposition
 move.b lrand(a5),(a2)+         * Linker Rand
 move.b optflag(a5),(a2)+       * Zeichensatz
 lea    edittabs(a5),a3
 moveq  #80-1,d0
saveed1:
 move.b (a3)+,(a2)+             * Alle Tab-Positionen
dbra    d0,saveed1
 lea    editmacro(a5),a3
 move   #41*10-1,d0
saveed2:
 move.b (a3)+,(a2)+             * Alle Macros des Editors
dbra    d0,saveed2
 move.l #'ENDE',(a2)+           * Endekennung
 moveq  #0,d1                   * 1 Sektor
 bsr    filesave                * JADOS-Funktion
bra     doserr

savedruck:
 lea    sadrdt0(pc),a0          * berschrift
 lea    sadrdt1(pc),a1          * Frage-Text
 moveq  #125,d3                 * Y-Koordinate
 bsr    doswerte                * Namen holen
 bcs    carset
 bsr    fillfcb
 bcs    doserr0                 * a1 = Buffer
 bsr    getfrei
 movea.l a0,a2
 move.l #'RDDR',(a2)+
 move.l #'UCKE',(a2)+           * Kennung, da es Druckerdaten sind
 move.b dflag0(a5),(a2)+        * Druckmodi
 move.b dflag1(a5),(a2)+        * Druckmodi
 move.b dflag2(a5),(a2)+        * Seitenlnge
 move.b dflag3(a5),(a2)+        * Linker Rand
 lea    drbeftab(a5),a3
 moveq  #3*22-1,d0
savedr0:
 move.b (a3)+,(a2)+             * Alle Druckerbefehle
dbra    d0,savedr0
 lea    drsave(a5),a3
 moveq  #20-1,d0
savedr1:
 move.b (a3)+,(a2)+             * Alle eigenen Befehle
dbra    d0,savedr1
 move.l #'ENDE',(a2)+           * Endekennung
 moveq  #0,d1                   * 1 Sektor
 bsr    filesave                * JADOS-Funktion
bra     doserr

loaddisk:                       * Daten von Disk laden
 bsr    dostest
 bcs    carset
 lea    menue31(pc),a0
 bsr    menueio
 cmp.b  #'1',d0
 beq.s  loaddatei
 cmp.b  #'2',d0
 beq.s  loadedit                * Editordaten laden
 cmp.b  #'3',d0
 beq    loaddruck               * Druckerdaten laden
rts

loaddatei:                      * Datei laden
 lea    lodadt0(pc),a0
 lea    lodadt1(pc),a1
 move   #160,d3
 bsr    doswerte
 bcs    carset
 bsr    fillfcb                 * Namen eintragen
 bcs    doserr0
 lea    lodadt2(pc),a0
 moveq  #90,d2
 bsr    doswert0
 bcs    carset
 bsr    wertmfeh
 bcs    carset
 movea.l d0,a0                  * Zieladresse
 lea    einbuf+40(a5),a1
 bsr    fileload                * JADOS-Funktion
bra     doserr

loadedit:
 lea    loeddt0(pc),a0          * berschrift
 lea    loeddt1(pc),a1          * Frage-Text
 moveq  #125,d3                 * Y-Koordinate
 bsr    doswerte                * Namen holen
 bcs    carset
loaded0:
 bsr    fillfcb
 bcs    doserr0                 * a1 = Buffer
 bsr    getfrei
 bsr    fileload                * JADOS-Funktion
 bsr    doserr
 bcs    carset
 cmp.l  #'RDED',(a0)+
 bne    doserr0
 cmp.l  #'ITOR',(a0)+           * Kennung, da es Editordaten sind
 bne    doserr0
 cmp.l  #'ENDE',494(a0)         * Endekennung
 bne    doserr0
 move.b (a0)+,groesse(a5)       * Ausgabegre
 move.b insl(a5),d0
 and.b  #%00000110,d0
 or.b (a0)+,d0                  * Einfgemode, Scroll-Art, Anfangsposition
 move.b d0,insl(a5)
 move.b (a0)+,lrand(a5)         * Linker Rand
 move.b (a0)+,optflag(a5)       * Zeichensatz
 lea    edittabs(a5),a1
 moveq  #80-1,d0
loaded1:
 move.b (a0)+,(a1)+             * Alle Tab-Positionen
dbra    d0,loaded1
 lea    editmacro(a5),a1
 move   #41*10-1,d0
loaded2:
 move.b (a0)+,(a1)+             * Alle Macrotexte
dbra    d0,loaded2
bra     carres

loaddruck:
 lea    lodrdt0(pc),a0          * berschrift
 lea    lodrdt1(pc),a1          * Frage-Text
 moveq  #125,d3                 * Y-Koordinate
 bsr    doswerte                * Namen holen
 bcs    carset
 bsr    fillfcb
 bcs    doserr0                 * a1 = Buffer
 bsr    getfrei
 bsr    fileload                * JADOS-Funktion
 bsr    doserr
 bcs    carset
 cmp.l  #'RDDR',(a0)+
 bne    doserr0
 cmp.l  #'UCKE',(a0)+           * Kennung, da es Druckerdaten sind
 bne    doserr0
 cmp.l  #'ENDE',90(a0)          * Endekennung
 bne    doserr0
 move.b (a0)+,dflag0(a5)        * Druckmodi
 move.b (a0)+,dflag1(a5)        * Druckmodi
 move.b (a0)+,dflag2(a5)        * Seitenlnge
 move.b (a0)+,dflag3(a5)        * Linker Rand
 lea    drbeftab(a5),a1
 moveq  #3*22-1,d0
loaddr0:
 move.b (a0)+,(a1)+             * Alle Druckerbefehle
dbra    d0,loaddr0
 lea    drsave(a5),a1
 moveq  #20-1,d0
loaddr1:
 move.b (a0)+,(a1)+             * Alle eigenen Befehle
dbra    d0,loaddr1
bra     carres

inhdisk:                       * Inhaltsverzeichnis ausgeben
 lea    inhdt0(pc),a0
 lea    inhdt1(pc),a1
 moveq  #125,d3
 bsr    doswerte
 bcs    carset
catalog:                        * a1 = Suchmuster
 movea.l a1,a0
 moveq  #11,d7                  * UPPERCAS
 trap   #6
 bsr    getfrei
 move   #$1400,d1               * 5 Kbyte Freiraum
 moveq  #0,d2                   * Nur Name
 moveq  #5,d3                   * 5 Spalten
 move   #1,passflag(a5)         * Keine Ausgabe ber JADOS
 moveq  #74,d7                  * DIRECTORY (JADOS-Funktion)
 trap   #6
 move   #2,passflag(a5)
 bsr    doserr
 bcs    carset
 bsr    clrscreen               * Ausgabe mit CO2
 bsr    prtco
 bsr    crlfe
 moveq  #6,d7                   * RESPONSE (JADOS-Funktion)
 trap   #6
 clr.b  flip(a5)                * Keine Seitenumschaltung
bra     carres

deldatei:                       * Datei lschen
 lea    deldt0(pc),a0
 lea    deldt1(pc),a1
 moveq  #125,d3
 bsr    doswerte
 bcs    carset
 bsr    fillfcb
 bcs    doserr0
 move   #1,passflag(a5)         * Keine Ausgabe ber JADOS
 moveq  #17,d7                  * ERASE (JADOS-Funktion)
 trap   #6
 move   #2,passflag(a5)
bra     doserr

kopdatei:                       * Datei kopieren
 lea    kopdt0(pc),a0
 lea    kopdt1(pc),a1
 lea    kopdt2(pc),a2
 moveq  #15,d6                  * COPYFILE (JADOS-Funktion)
kopdat0:
 move   #160,d3
 bsr    doswerte                * Alten Namen holen
 bcs    carset
 bsr    fillfcb
 bcs    doserr0
 movea.l a2,a0
 moveq  #90,d2
 bsr    doswert0                * Neuer Name
 bcs    carset
 lea    ausbuf(a5),a1
 bsr    fillfcb0
 bcs    doserr0
 lea    einbuf+40(a5),a1
 lea    ausbuf(a5),a2
 move   #1,passflag(a5)         * Keine Ausgabe ber JADOS
 moveq  #58,d7                  * GETLADDR (JADOS-Funktion)
 trap   #6                      * Diese Funktion wird bei rendatei nicht
                                * bentigt, strt aber nicht bei COPYFILE
 move   d6,d7                   * JADOS-Funktion
 trap   #6
 move   #2,passflag(a5)
bra     doserr

rendatei:                       * Datei umbenennen
 lea    rendt0(pc),a0
 lea    rendt1(pc),a1
 lea    rendt2(pc),a2
 moveq  #21,d6                  * RENAME (JADOS-Funktion)
bra.s kopdat0

fillfcb:                        * JADOS-Funktion
 lea    einbuf+40(a5),a1        * Ziel fr Dateisteuerblock
fillfcb0:
 moveq  #11,d7                  * UPPERCAS
 trap   #6
 moveq  #18,d7                  * FILLFCB
 trap   #6
 tst.b  d0
 beq    carres                  * OK
bra     carset                  * Fehler

doswerte:
 bsr    dostest
 bcs    carset
 bsr    headaclr                * berschrift
 movea.l a1,a0
 move   d3,d2
doswert0:
 lea    einbuf+90(a5),a1        * Ziel fr Namen
 moveq  #$33,d0
 moveq  #5,d1
 bsr    textaus                 * Frage-Text
 sub    #25,d2                  * etwas tiefer
 movea.l a1,a0                  * Adresse Ziel
 moveq  #$22,d0
 moveq  #40,d3                  * 40 Zeichen
 bsr    textein                 * Text holen
 bcs    carset                  * Abbruch
 tst    d4
 beq    carset                  * Kein Zeichen, dann Fehler
 movea.l a1,a0
bra     carres                  * Sonst OK

doserr:                         * d0 sind Fehlermglichkeiten
 moveq  #5,d7                   * Floppy-Motoren ausschalten
 trap   #6
 tst.b  d0                      * Fehler ?
 beq    carres                  * Nein
 lea    dostxt2(pc),a0          * Diskette voll
 cmp.b  #2,d0
 beq.s  doserr1
 lea    dostxt3(pc),a0          * Datei nicht vorhanden
 cmp.b  #3,d0
 beq.s  doserr1
 lea    dostxt4(pc),a0          * Neuer Name existiert bereits
 cmp.b  #4,d0
 beq.s  doserr1
 lea    dostxt5(pc),a0          * Diskette voll
 cmp.b  #5,d0
 beq.s  doserr1
 lea    dostxt99(pc),a0         * Nicht genug RAM
 cmp.b  #99,d0
 beq.s  doserr1
doserr0:
 lea    dostxt(pc),a0           * Fehler
doserr1:
 moveq  #$33,d0
 moveq  #10,d2
 bsr    centertxt               * Fehlertext mittig ausgeben
 moveq  #20,d0
 bsr    delay                   * 2 Sekunden warten
bra     carset                  * Fehler

fileload:
 move   #1,passflag(a5)         * Keine Ausgabe ber JADOS
 moveq  #44,d7
 trap   #6
bra.s   files0

filesave:
 move   #1,passflag(a5)         * Keine Ausgabe ber JADOS
 moveq  #45,d7
 trap   #6
files0:
 move   #2,passflag(a5)
rts


